/* chess-state.c generated by valac 0.56.14, the Vala compiler
 * generated from chess-state.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "libchess.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

enum  {
	CHESS_STATE_0_PROPERTY,
	CHESS_STATE_OPPONENT_PROPERTY,
	CHESS_STATE_NUM_PROPERTIES
};
static GParamSpec* chess_state_properties[CHESS_STATE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _ChessStatePrivate {
	gint64 piece_masks[2];
};

static gint ChessState_private_offset;
static gpointer chess_state_parent_class = NULL;

static ChessState* chess_state_new_empty (void);
static ChessState* chess_state_construct_empty (GType object_type);
static gboolean chess_state_decode_piece_type (ChessState* self,
                                        gunichar c,
                                        PieceType* type);
static CheckState chess_state_get_check_state (ChessState* self,
                                        ChessPlayer* player);
static gboolean chess_state_decode_move (ChessState* self,
                                  ChessPlayer* player,
                                  const gchar* move,
                                  gint* r0,
                                  gint* f0,
                                  gint* r1,
                                  gint* f1,
                                  PieceType* promotion_type);
static gboolean chess_state_is_in_checkmate (ChessState* self,
                                      ChessPlayer* player);
static void chess_state_finalize (GObject * obj);
static GType chess_state_get_type_once (void);
static void _vala_chess_state_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const gint64 BIT_BOARD_set_location_masks[64];
VALA_EXTERN const gint64 BIT_BOARD_move_masks[768];
VALA_EXTERN const gint64 BIT_BOARD_over_masks[4096];
VALA_EXTERN const gint64 BIT_BOARD_clear_location_masks[64];

static GType
check_state_get_type_once (void)
{
	static const GEnumValue values[] = {{CHECK_STATE_NONE, "CHECK_STATE_NONE", "none"}, {CHECK_STATE_CHECK, "CHECK_STATE_CHECK", "check"}, {CHECK_STATE_CHECKMATE, "CHECK_STATE_CHECKMATE", "checkmate"}, {0, NULL, NULL}};
	GType check_state_type_id;
	check_state_type_id = g_enum_register_static ("CheckState", values);
	return check_state_type_id;
}

GType
check_state_get_type (void)
{
	static volatile gsize check_state_type_id__once = 0;
	if (g_once_init_enter (&check_state_type_id__once)) {
		GType check_state_type_id;
		check_state_type_id = check_state_get_type_once ();
		g_once_init_leave (&check_state_type_id__once, check_state_type_id);
	}
	return check_state_type_id__once;
}

static inline gpointer
chess_state_get_instance_private (ChessState* self)
{
	return G_STRUCT_MEMBER_P (self, ChessState_private_offset);
}

static ChessState*
chess_state_construct_empty (GType object_type)
{
	ChessState * self = NULL;
#line 41 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 41 "../lib/chess-state.vala"
	return self;
#line 117 "chess-state.c"
}

static ChessState*
chess_state_new_empty (void)
{
#line 41 "../lib/chess-state.vala"
	return chess_state_construct_empty (TYPE_CHESS_STATE);
#line 125 "chess-state.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 142 "chess-state.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../lib/chess-state.vala"
	return self ? g_object_ref (self) : NULL;
#line 150 "chess-state.c"
}

ChessState*
chess_state_construct (GType object_type,
                       const gchar* fen)
{
	ChessState * self = NULL;
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	gchar** fields = NULL;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint fields_length1;
	gint _fields_size_;
	gchar** ranks = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint ranks_length1;
	gint _ranks_size_;
	gchar** _tmp31_;
	gint _tmp31__length1;
	const gchar* _tmp32_;
	gchar** _tmp39_;
	gint _tmp39__length1;
	const gchar* _tmp40_;
	gchar** _tmp49_;
	gint _tmp49__length1;
	const gchar* _tmp50_;
	gchar** _tmp55_;
	gint _tmp55__length1;
	const gchar* _tmp56_;
	gchar** _tmp57_;
	gint _tmp57__length1;
	const gchar* _tmp58_;
	ChessPlayer* _tmp59_;
	ChessPlayer* _tmp61_;
#line 46 "../lib/chess-state.vala"
	g_return_val_if_fail (fen != NULL, NULL);
#line 46 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 48 "../lib/chess-state.vala"
	_tmp0_ = chess_player_new (COLOR_WHITE);
#line 48 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_WHITE]);
#line 48 "../lib/chess-state.vala"
	self->players[COLOR_WHITE] = _tmp0_;
#line 49 "../lib/chess-state.vala"
	_tmp1_ = chess_player_new (COLOR_BLACK);
#line 49 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_BLACK]);
#line 49 "../lib/chess-state.vala"
	self->players[COLOR_BLACK] = _tmp1_;
#line 206 "chess-state.c"
	{
		gint i = 0;
#line 50 "../lib/chess-state.vala"
		i = 0;
#line 211 "chess-state.c"
		{
			gboolean _tmp2_ = FALSE;
#line 50 "../lib/chess-state.vala"
			_tmp2_ = TRUE;
#line 50 "../lib/chess-state.vala"
			while (TRUE) {
#line 50 "../lib/chess-state.vala"
				if (!_tmp2_) {
#line 220 "chess-state.c"
					gint _tmp3_;
#line 50 "../lib/chess-state.vala"
					_tmp3_ = i;
#line 50 "../lib/chess-state.vala"
					i = _tmp3_ + 1;
#line 226 "chess-state.c"
				}
#line 50 "../lib/chess-state.vala"
				_tmp2_ = FALSE;
#line 50 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 50 "../lib/chess-state.vala"
					break;
#line 234 "chess-state.c"
				}
#line 51 "../lib/chess-state.vala"
				_g_object_unref0 (self->board[i]);
#line 51 "../lib/chess-state.vala"
				self->board[i] = NULL;
#line 240 "chess-state.c"
			}
		}
	}
#line 53 "../lib/chess-state.vala"
	_tmp5_ = _tmp4_ = g_strsplit (fen, " ", 0);
#line 53 "../lib/chess-state.vala"
	fields = _tmp5_;
#line 53 "../lib/chess-state.vala"
	fields_length1 = _vala_array_length (_tmp4_);
#line 53 "../lib/chess-state.vala"
	_fields_size_ = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp6_ = fields;
#line 58 "../lib/chess-state.vala"
	_tmp6__length1 = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp7_ = _tmp6_[0];
#line 58 "../lib/chess-state.vala"
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "/", 0);
#line 58 "../lib/chess-state.vala"
	ranks = _tmp9_;
#line 58 "../lib/chess-state.vala"
	ranks_length1 = _vala_array_length (_tmp8_);
#line 58 "../lib/chess-state.vala"
	_ranks_size_ = ranks_length1;
#line 266 "chess-state.c"
	{
		gint rank = 0;
#line 61 "../lib/chess-state.vala"
		rank = 0;
#line 271 "chess-state.c"
		{
			gboolean _tmp10_ = FALSE;
#line 61 "../lib/chess-state.vala"
			_tmp10_ = TRUE;
#line 61 "../lib/chess-state.vala"
			while (TRUE) {
#line 278 "chess-state.c"
				gchar* rank_string = NULL;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 61 "../lib/chess-state.vala"
				if (!_tmp10_) {
#line 286 "chess-state.c"
					gint _tmp11_;
#line 61 "../lib/chess-state.vala"
					_tmp11_ = rank;
#line 61 "../lib/chess-state.vala"
					rank = _tmp11_ + 1;
#line 292 "chess-state.c"
				}
#line 61 "../lib/chess-state.vala"
				_tmp10_ = FALSE;
#line 61 "../lib/chess-state.vala"
				if (!(rank < 8)) {
#line 61 "../lib/chess-state.vala"
					break;
#line 300 "chess-state.c"
				}
#line 63 "../lib/chess-state.vala"
				_tmp12_ = ranks;
#line 63 "../lib/chess-state.vala"
				_tmp12__length1 = ranks_length1;
#line 63 "../lib/chess-state.vala"
				_tmp13_ = _tmp12_[7 - rank];
#line 63 "../lib/chess-state.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 63 "../lib/chess-state.vala"
				rank_string = _tmp14_;
#line 312 "chess-state.c"
				{
					gint file = 0;
					gint offset = 0;
#line 64 "../lib/chess-state.vala"
					file = 0;
#line 64 "../lib/chess-state.vala"
					offset = 0;
#line 320 "chess-state.c"
					{
						gboolean _tmp15_ = FALSE;
#line 64 "../lib/chess-state.vala"
						_tmp15_ = TRUE;
#line 64 "../lib/chess-state.vala"
						while (TRUE) {
#line 327 "chess-state.c"
							gboolean _tmp17_ = FALSE;
							gchar c = '\0';
							const gchar* _tmp21_;
							gboolean _tmp22_ = FALSE;
							PieceType type = 0;
							Color _tmp23_ = 0;
							Color color = 0;
							PieceType _tmp24_ = 0;
							gint index = 0;
							ChessPiece* piece = NULL;
							ChessPlayer* _tmp25_;
							ChessPiece* _tmp26_;
							ChessPiece* _tmp27_;
							ChessPiece* _tmp28_;
							gint64 mask = 0LL;
							gint64 _tmp29_;
							gint _tmp30_;
#line 64 "../lib/chess-state.vala"
							if (!_tmp15_) {
#line 347 "chess-state.c"
								gint _tmp16_;
#line 64 "../lib/chess-state.vala"
								_tmp16_ = offset;
#line 64 "../lib/chess-state.vala"
								offset = _tmp16_ + 1;
#line 353 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							_tmp15_ = FALSE;
#line 64 "../lib/chess-state.vala"
							if (file < 8) {
#line 359 "chess-state.c"
								const gchar* _tmp18_;
								gint _tmp19_;
								gint _tmp20_;
#line 64 "../lib/chess-state.vala"
								_tmp18_ = rank_string;
#line 64 "../lib/chess-state.vala"
								_tmp19_ = strlen (_tmp18_);
#line 64 "../lib/chess-state.vala"
								_tmp20_ = _tmp19_;
#line 64 "../lib/chess-state.vala"
								_tmp17_ = offset < _tmp20_;
#line 371 "chess-state.c"
							} else {
#line 64 "../lib/chess-state.vala"
								_tmp17_ = FALSE;
#line 375 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							if (!_tmp17_) {
#line 64 "../lib/chess-state.vala"
								break;
#line 381 "chess-state.c"
							}
#line 66 "../lib/chess-state.vala"
							_tmp21_ = rank_string;
#line 66 "../lib/chess-state.vala"
							c = string_get (_tmp21_, (glong) offset);
#line 67 "../lib/chess-state.vala"
							if (c >= '1') {
#line 67 "../lib/chess-state.vala"
								_tmp22_ = c <= '8';
#line 391 "chess-state.c"
							} else {
#line 67 "../lib/chess-state.vala"
								_tmp22_ = FALSE;
#line 395 "chess-state.c"
							}
#line 67 "../lib/chess-state.vala"
							if (_tmp22_) {
#line 69 "../lib/chess-state.vala"
								file += (gint) (c - '0');
#line 70 "../lib/chess-state.vala"
								continue;
#line 403 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							if (g_ascii_isupper (c)) {
#line 74 "../lib/chess-state.vala"
								_tmp23_ = COLOR_WHITE;
#line 409 "chess-state.c"
							} else {
#line 74 "../lib/chess-state.vala"
								_tmp23_ = COLOR_BLACK;
#line 413 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							color = _tmp23_;
#line 75 "../lib/chess-state.vala"
							chess_state_decode_piece_type (self, (gunichar) g_ascii_toupper (c), &_tmp24_);
#line 75 "../lib/chess-state.vala"
							type = _tmp24_;
#line 78 "../lib/chess-state.vala"
							index = chess_state_get_index (self, rank, file);
#line 79 "../lib/chess-state.vala"
							_tmp25_ = self->players[color];
#line 79 "../lib/chess-state.vala"
							_tmp26_ = chess_piece_new (_tmp25_, type);
#line 79 "../lib/chess-state.vala"
							piece = _tmp26_;
#line 80 "../lib/chess-state.vala"
							_tmp27_ = piece;
#line 80 "../lib/chess-state.vala"
							_tmp28_ = _g_object_ref0 (_tmp27_);
#line 80 "../lib/chess-state.vala"
							_g_object_unref0 (self->board[index]);
#line 80 "../lib/chess-state.vala"
							self->board[index] = _tmp28_;
#line 81 "../lib/chess-state.vala"
							_tmp29_ = BIT_BOARD_set_location_masks[index];
#line 81 "../lib/chess-state.vala"
							mask = _tmp29_;
#line 82 "../lib/chess-state.vala"
							self->priv->piece_masks[color] |= mask;
#line 83 "../lib/chess-state.vala"
							_tmp30_ = file;
#line 83 "../lib/chess-state.vala"
							file = _tmp30_ + 1;
#line 64 "../lib/chess-state.vala"
							_g_object_unref0 (piece);
#line 449 "chess-state.c"
						}
					}
				}
#line 61 "../lib/chess-state.vala"
				_g_free0 (rank_string);
#line 455 "chess-state.c"
			}
		}
	}
#line 88 "../lib/chess-state.vala"
	_tmp31_ = fields;
#line 88 "../lib/chess-state.vala"
	_tmp31__length1 = fields_length1;
#line 88 "../lib/chess-state.vala"
	_tmp32_ = _tmp31_[1];
#line 88 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp32_, "w") == 0) {
#line 467 "chess-state.c"
		ChessPlayer* _tmp33_;
		ChessPlayer* _tmp34_;
#line 89 "../lib/chess-state.vala"
		_tmp33_ = self->players[COLOR_WHITE];
#line 89 "../lib/chess-state.vala"
		_tmp34_ = _g_object_ref0 (_tmp33_);
#line 89 "../lib/chess-state.vala"
		_g_object_unref0 (self->current_player);
#line 89 "../lib/chess-state.vala"
		self->current_player = _tmp34_;
#line 478 "chess-state.c"
	} else {
		gchar** _tmp35_;
		gint _tmp35__length1;
		const gchar* _tmp36_;
#line 90 "../lib/chess-state.vala"
		_tmp35_ = fields;
#line 90 "../lib/chess-state.vala"
		_tmp35__length1 = fields_length1;
#line 90 "../lib/chess-state.vala"
		_tmp36_ = _tmp35_[1];
#line 90 "../lib/chess-state.vala"
		if (g_strcmp0 (_tmp36_, "b") == 0) {
#line 491 "chess-state.c"
			ChessPlayer* _tmp37_;
			ChessPlayer* _tmp38_;
#line 91 "../lib/chess-state.vala"
			_tmp37_ = self->players[COLOR_BLACK];
#line 91 "../lib/chess-state.vala"
			_tmp38_ = _g_object_ref0 (_tmp37_);
#line 91 "../lib/chess-state.vala"
			_g_object_unref0 (self->current_player);
#line 91 "../lib/chess-state.vala"
			self->current_player = _tmp38_;
#line 502 "chess-state.c"
		}
	}
#line 96 "../lib/chess-state.vala"
	_tmp39_ = fields;
#line 96 "../lib/chess-state.vala"
	_tmp39__length1 = fields_length1;
#line 96 "../lib/chess-state.vala"
	_tmp40_ = _tmp39_[2];
#line 96 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp40_, "-") != 0) {
#line 513 "chess-state.c"
		{
			gint i = 0;
#line 98 "../lib/chess-state.vala"
			i = 0;
#line 518 "chess-state.c"
			{
				gboolean _tmp41_ = FALSE;
#line 98 "../lib/chess-state.vala"
				_tmp41_ = TRUE;
#line 98 "../lib/chess-state.vala"
				while (TRUE) {
#line 525 "chess-state.c"
					gchar** _tmp43_;
					gint _tmp43__length1;
					const gchar* _tmp44_;
					gint _tmp45_;
					gint _tmp46_;
					gchar c = '\0';
					gchar** _tmp47_;
					gint _tmp47__length1;
					const gchar* _tmp48_;
#line 98 "../lib/chess-state.vala"
					if (!_tmp41_) {
#line 537 "chess-state.c"
						gint _tmp42_;
#line 98 "../lib/chess-state.vala"
						_tmp42_ = i;
#line 98 "../lib/chess-state.vala"
						i = _tmp42_ + 1;
#line 543 "chess-state.c"
					}
#line 98 "../lib/chess-state.vala"
					_tmp41_ = FALSE;
#line 98 "../lib/chess-state.vala"
					_tmp43_ = fields;
#line 98 "../lib/chess-state.vala"
					_tmp43__length1 = fields_length1;
#line 98 "../lib/chess-state.vala"
					_tmp44_ = _tmp43_[2];
#line 98 "../lib/chess-state.vala"
					_tmp45_ = strlen (_tmp44_);
#line 98 "../lib/chess-state.vala"
					_tmp46_ = _tmp45_;
#line 98 "../lib/chess-state.vala"
					if (!(i < _tmp46_)) {
#line 98 "../lib/chess-state.vala"
						break;
#line 561 "chess-state.c"
					}
#line 100 "../lib/chess-state.vala"
					_tmp47_ = fields;
#line 100 "../lib/chess-state.vala"
					_tmp47__length1 = fields_length1;
#line 100 "../lib/chess-state.vala"
					_tmp48_ = _tmp47_[2];
#line 100 "../lib/chess-state.vala"
					c = string_get (_tmp48_, (glong) i);
#line 101 "../lib/chess-state.vala"
					if (c == 'K') {
#line 102 "../lib/chess-state.vala"
						self->can_castle_kingside[COLOR_WHITE] = TRUE;
#line 575 "chess-state.c"
					} else {
#line 103 "../lib/chess-state.vala"
						if (c == 'Q') {
#line 104 "../lib/chess-state.vala"
							self->can_castle_queenside[COLOR_WHITE] = TRUE;
#line 581 "chess-state.c"
						} else {
#line 105 "../lib/chess-state.vala"
							if (c == 'k') {
#line 106 "../lib/chess-state.vala"
								self->can_castle_kingside[COLOR_BLACK] = TRUE;
#line 587 "chess-state.c"
							} else {
#line 107 "../lib/chess-state.vala"
								if (c == 'q') {
#line 108 "../lib/chess-state.vala"
									self->can_castle_queenside[COLOR_BLACK] = TRUE;
#line 593 "chess-state.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 115 "../lib/chess-state.vala"
	_tmp49_ = fields;
#line 115 "../lib/chess-state.vala"
	_tmp49__length1 = fields_length1;
#line 115 "../lib/chess-state.vala"
	_tmp50_ = _tmp49_[3];
#line 115 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp50_, "-") != 0) {
#line 610 "chess-state.c"
		gchar** _tmp51_;
		gint _tmp51__length1;
		const gchar* _tmp52_;
		gchar** _tmp53_;
		gint _tmp53__length1;
		const gchar* _tmp54_;
#line 119 "../lib/chess-state.vala"
		_tmp51_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp51__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp52_ = _tmp51_[3];
#line 119 "../lib/chess-state.vala"
		_tmp53_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp53__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp54_ = _tmp53_[3];
#line 119 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (gint) (string_get (_tmp52_, (glong) 1) - '1'), (gint) (string_get (_tmp54_, (glong) 0) - 'a'));
#line 631 "chess-state.c"
	}
#line 123 "../lib/chess-state.vala"
	_tmp55_ = fields;
#line 123 "../lib/chess-state.vala"
	_tmp55__length1 = fields_length1;
#line 123 "../lib/chess-state.vala"
	_tmp56_ = _tmp55_[4];
#line 123 "../lib/chess-state.vala"
	self->halfmove_clock = atoi (_tmp56_);
#line 126 "../lib/chess-state.vala"
	_tmp57_ = fields;
#line 126 "../lib/chess-state.vala"
	_tmp57__length1 = fields_length1;
#line 126 "../lib/chess-state.vala"
	_tmp58_ = _tmp57_[5];
#line 126 "../lib/chess-state.vala"
	self->number = (atoi (_tmp58_) - 1) * 2;
#line 127 "../lib/chess-state.vala"
	_tmp59_ = self->current_player;
#line 127 "../lib/chess-state.vala"
	if (_tmp59_->color == COLOR_BLACK) {
#line 653 "chess-state.c"
		gint _tmp60_;
#line 128 "../lib/chess-state.vala"
		_tmp60_ = self->number;
#line 128 "../lib/chess-state.vala"
		self->number = _tmp60_ + 1;
#line 659 "chess-state.c"
	}
#line 130 "../lib/chess-state.vala"
	_tmp61_ = self->current_player;
#line 130 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp61_);
#line 46 "../lib/chess-state.vala"
	ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	return self;
#line 671 "chess-state.c"
}

ChessState*
chess_state_new (const gchar* fen)
{
#line 46 "../lib/chess-state.vala"
	return chess_state_construct (TYPE_CHESS_STATE, fen);
#line 679 "chess-state.c"
}

ChessState*
chess_state_copy (ChessState* self)
{
	ChessState* state = NULL;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	ChessState* _tmp2_;
	ChessPlayer* _tmp3_;
	ChessPlayer* _tmp4_;
	ChessState* _tmp5_;
	ChessPlayer* _tmp6_;
	ChessPlayer* _tmp7_;
	ChessState* _tmp8_;
	ChessPlayer* _tmp9_;
	ChessPlayer* _tmp10_;
	ChessState* _tmp11_;
	gboolean _tmp12_;
	ChessState* _tmp13_;
	gboolean _tmp14_;
	ChessState* _tmp15_;
	gboolean _tmp16_;
	ChessState* _tmp17_;
	gboolean _tmp18_;
	ChessState* _tmp19_;
	ChessState* _tmp20_;
	ChessMove* _tmp21_;
	ChessState* _tmp30_;
	gint64 _tmp31_;
	ChessState* _tmp32_;
	gint64 _tmp33_;
	ChessState* _tmp34_;
	ChessState* result;
#line 133 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../lib/chess-state.vala"
	_tmp0_ = chess_state_new_empty ();
#line 135 "../lib/chess-state.vala"
	state = _tmp0_;
#line 137 "../lib/chess-state.vala"
	_tmp1_ = state;
#line 137 "../lib/chess-state.vala"
	_tmp1_->number = self->number;
#line 138 "../lib/chess-state.vala"
	_tmp2_ = state;
#line 138 "../lib/chess-state.vala"
	_tmp3_ = self->players[COLOR_WHITE];
#line 138 "../lib/chess-state.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 138 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp2_->players[COLOR_WHITE]);
#line 138 "../lib/chess-state.vala"
	_tmp2_->players[COLOR_WHITE] = _tmp4_;
#line 139 "../lib/chess-state.vala"
	_tmp5_ = state;
#line 139 "../lib/chess-state.vala"
	_tmp6_ = self->players[COLOR_BLACK];
#line 139 "../lib/chess-state.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 139 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp5_->players[COLOR_BLACK]);
#line 139 "../lib/chess-state.vala"
	_tmp5_->players[COLOR_BLACK] = _tmp7_;
#line 140 "../lib/chess-state.vala"
	_tmp8_ = state;
#line 140 "../lib/chess-state.vala"
	_tmp9_ = self->current_player;
#line 140 "../lib/chess-state.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 140 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp8_->current_player);
#line 140 "../lib/chess-state.vala"
	_tmp8_->current_player = _tmp10_;
#line 141 "../lib/chess-state.vala"
	_tmp11_ = state;
#line 141 "../lib/chess-state.vala"
	_tmp12_ = self->can_castle_kingside[COLOR_WHITE];
#line 141 "../lib/chess-state.vala"
	_tmp11_->can_castle_kingside[COLOR_WHITE] = _tmp12_;
#line 142 "../lib/chess-state.vala"
	_tmp13_ = state;
#line 142 "../lib/chess-state.vala"
	_tmp14_ = self->can_castle_queenside[COLOR_WHITE];
#line 142 "../lib/chess-state.vala"
	_tmp13_->can_castle_queenside[COLOR_WHITE] = _tmp14_;
#line 143 "../lib/chess-state.vala"
	_tmp15_ = state;
#line 143 "../lib/chess-state.vala"
	_tmp16_ = self->can_castle_kingside[COLOR_BLACK];
#line 143 "../lib/chess-state.vala"
	_tmp15_->can_castle_kingside[COLOR_BLACK] = _tmp16_;
#line 144 "../lib/chess-state.vala"
	_tmp17_ = state;
#line 144 "../lib/chess-state.vala"
	_tmp18_ = self->can_castle_queenside[COLOR_BLACK];
#line 144 "../lib/chess-state.vala"
	_tmp17_->can_castle_queenside[COLOR_BLACK] = _tmp18_;
#line 145 "../lib/chess-state.vala"
	_tmp19_ = state;
#line 145 "../lib/chess-state.vala"
	_tmp19_->en_passant_index = self->en_passant_index;
#line 146 "../lib/chess-state.vala"
	_tmp20_ = state;
#line 146 "../lib/chess-state.vala"
	_tmp20_->check_state = self->check_state;
#line 147 "../lib/chess-state.vala"
	_tmp21_ = self->last_move;
#line 147 "../lib/chess-state.vala"
	if (_tmp21_ != NULL) {
#line 790 "chess-state.c"
		ChessState* _tmp22_;
		ChessMove* _tmp23_;
		ChessMove* _tmp24_;
#line 148 "../lib/chess-state.vala"
		_tmp22_ = state;
#line 148 "../lib/chess-state.vala"
		_tmp23_ = self->last_move;
#line 148 "../lib/chess-state.vala"
		_tmp24_ = chess_move_copy (_tmp23_);
#line 148 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp22_->last_move);
#line 148 "../lib/chess-state.vala"
		_tmp22_->last_move = _tmp24_;
#line 804 "chess-state.c"
	}
	{
		gint i = 0;
#line 149 "../lib/chess-state.vala"
		i = 0;
#line 810 "chess-state.c"
		{
			gboolean _tmp25_ = FALSE;
#line 149 "../lib/chess-state.vala"
			_tmp25_ = TRUE;
#line 149 "../lib/chess-state.vala"
			while (TRUE) {
#line 817 "chess-state.c"
				ChessState* _tmp27_;
				ChessPiece* _tmp28_;
				ChessPiece* _tmp29_;
#line 149 "../lib/chess-state.vala"
				if (!_tmp25_) {
#line 823 "chess-state.c"
					gint _tmp26_;
#line 149 "../lib/chess-state.vala"
					_tmp26_ = i;
#line 149 "../lib/chess-state.vala"
					i = _tmp26_ + 1;
#line 829 "chess-state.c"
				}
#line 149 "../lib/chess-state.vala"
				_tmp25_ = FALSE;
#line 149 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 149 "../lib/chess-state.vala"
					break;
#line 837 "chess-state.c"
				}
#line 150 "../lib/chess-state.vala"
				_tmp27_ = state;
#line 150 "../lib/chess-state.vala"
				_tmp28_ = self->board[i];
#line 150 "../lib/chess-state.vala"
				_tmp29_ = _g_object_ref0 (_tmp28_);
#line 150 "../lib/chess-state.vala"
				_g_object_unref0 (_tmp27_->board[i]);
#line 150 "../lib/chess-state.vala"
				_tmp27_->board[i] = _tmp29_;
#line 849 "chess-state.c"
			}
		}
	}
#line 151 "../lib/chess-state.vala"
	_tmp30_ = state;
#line 151 "../lib/chess-state.vala"
	_tmp31_ = self->priv->piece_masks[COLOR_WHITE];
#line 151 "../lib/chess-state.vala"
	_tmp30_->priv->piece_masks[COLOR_WHITE] = _tmp31_;
#line 152 "../lib/chess-state.vala"
	_tmp32_ = state;
#line 152 "../lib/chess-state.vala"
	_tmp33_ = self->priv->piece_masks[COLOR_BLACK];
#line 152 "../lib/chess-state.vala"
	_tmp32_->priv->piece_masks[COLOR_BLACK] = _tmp33_;
#line 153 "../lib/chess-state.vala"
	_tmp34_ = state;
#line 153 "../lib/chess-state.vala"
	_tmp34_->halfmove_clock = self->halfmove_clock;
#line 155 "../lib/chess-state.vala"
	result = state;
#line 155 "../lib/chess-state.vala"
	return result;
#line 873 "chess-state.c"
}

gboolean
chess_state_equals (ChessState* self,
                    ChessState* state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gint64 _tmp7_;
	gint64 _tmp8_;
	gboolean result;
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 168 "../lib/chess-state.vala"
	_tmp7_ = self->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	_tmp8_ = state->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	if (_tmp7_ != _tmp8_) {
#line 168 "../lib/chess-state.vala"
		_tmp6_ = TRUE;
#line 902 "chess-state.c"
	} else {
		gint64 _tmp9_;
		gint64 _tmp10_;
#line 169 "../lib/chess-state.vala"
		_tmp9_ = self->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp10_ = state->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp6_ = _tmp9_ != _tmp10_;
#line 912 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp6_) {
#line 168 "../lib/chess-state.vala"
		_tmp5_ = TRUE;
#line 918 "chess-state.c"
	} else {
		ChessPlayer* _tmp11_;
		ChessPlayer* _tmp12_;
#line 170 "../lib/chess-state.vala"
		_tmp11_ = self->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp12_ = state->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp5_ = _tmp11_->color != _tmp12_->color;
#line 928 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp5_) {
#line 168 "../lib/chess-state.vala"
		_tmp4_ = TRUE;
#line 934 "chess-state.c"
	} else {
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 171 "../lib/chess-state.vala"
		_tmp13_ = self->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp14_ = state->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp4_ = _tmp13_ != _tmp14_;
#line 944 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp4_) {
#line 168 "../lib/chess-state.vala"
		_tmp3_ = TRUE;
#line 950 "chess-state.c"
	} else {
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 172 "../lib/chess-state.vala"
		_tmp15_ = self->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp16_ = state->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp3_ = _tmp15_ != _tmp16_;
#line 960 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp3_) {
#line 168 "../lib/chess-state.vala"
		_tmp2_ = TRUE;
#line 966 "chess-state.c"
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 173 "../lib/chess-state.vala"
		_tmp17_ = self->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp18_ = state->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp2_ = _tmp17_ != _tmp18_;
#line 976 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp2_) {
#line 168 "../lib/chess-state.vala"
		_tmp1_ = TRUE;
#line 982 "chess-state.c"
	} else {
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 174 "../lib/chess-state.vala"
		_tmp19_ = self->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp20_ = state->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp1_ = _tmp19_ != _tmp20_;
#line 992 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp1_) {
#line 168 "../lib/chess-state.vala"
		_tmp0_ = TRUE;
#line 998 "chess-state.c"
	} else {
#line 175 "../lib/chess-state.vala"
		_tmp0_ = self->en_passant_index != state->en_passant_index;
#line 1002 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp0_) {
#line 176 "../lib/chess-state.vala"
		result = FALSE;
#line 176 "../lib/chess-state.vala"
		return result;
#line 1010 "chess-state.c"
	}
	{
		gint i = 0;
#line 179 "../lib/chess-state.vala"
		i = 0;
#line 1016 "chess-state.c"
		{
			gboolean _tmp21_ = FALSE;
#line 179 "../lib/chess-state.vala"
			_tmp21_ = TRUE;
#line 179 "../lib/chess-state.vala"
			while (TRUE) {
#line 1023 "chess-state.c"
				gboolean _tmp23_ = FALSE;
				ChessPiece* _tmp24_;
#line 179 "../lib/chess-state.vala"
				if (!_tmp21_) {
#line 1028 "chess-state.c"
					gint _tmp22_;
#line 179 "../lib/chess-state.vala"
					_tmp22_ = i;
#line 179 "../lib/chess-state.vala"
					i = _tmp22_ + 1;
#line 1034 "chess-state.c"
				}
#line 179 "../lib/chess-state.vala"
				_tmp21_ = FALSE;
#line 179 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 179 "../lib/chess-state.vala"
					break;
#line 1042 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				_tmp24_ = self->board[i];
#line 181 "../lib/chess-state.vala"
				if (_tmp24_ != NULL) {
#line 1048 "chess-state.c"
					ChessPiece* _tmp25_;
					ChessPiece* _tmp26_;
#line 181 "../lib/chess-state.vala"
					_tmp25_ = self->board[i];
#line 181 "../lib/chess-state.vala"
					_tmp26_ = state->board[i];
#line 181 "../lib/chess-state.vala"
					_tmp23_ = _tmp25_->type != _tmp26_->type;
#line 1057 "chess-state.c"
				} else {
#line 181 "../lib/chess-state.vala"
					_tmp23_ = FALSE;
#line 1061 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				if (_tmp23_) {
#line 182 "../lib/chess-state.vala"
					result = FALSE;
#line 182 "../lib/chess-state.vala"
					return result;
#line 1069 "chess-state.c"
				}
			}
		}
	}
#line 185 "../lib/chess-state.vala"
	result = TRUE;
#line 185 "../lib/chess-state.vala"
	return result;
#line 1078 "chess-state.c"
}

gchar*
chess_state_get_fen (ChessState* self)
{
	GString* value = NULL;
	GString* _tmp0_;
	GString* _tmp16_;
	ChessPlayer* _tmp17_;
	GString* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp23_;
	gboolean _tmp25_;
	gboolean _tmp27_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	GString* _tmp34_;
	GString* _tmp37_;
	GString* _tmp38_;
	GString* _tmp39_;
	ChessPlayer* _tmp40_;
	GString* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* result;
#line 188 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../lib/chess-state.vala"
	_tmp0_ = g_string_new ("");
#line 190 "../lib/chess-state.vala"
	value = _tmp0_;
#line 1112 "chess-state.c"
	{
		gint rank = 0;
#line 192 "../lib/chess-state.vala"
		rank = 7;
#line 1117 "chess-state.c"
		{
			gboolean _tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
			_tmp1_ = TRUE;
#line 192 "../lib/chess-state.vala"
			while (TRUE) {
#line 1124 "chess-state.c"
				gint skip_count = 0;
#line 192 "../lib/chess-state.vala"
				if (!_tmp1_) {
#line 1128 "chess-state.c"
					gint _tmp2_;
#line 192 "../lib/chess-state.vala"
					_tmp2_ = rank;
#line 192 "../lib/chess-state.vala"
					rank = _tmp2_ - 1;
#line 1134 "chess-state.c"
				}
#line 192 "../lib/chess-state.vala"
				_tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
				if (!(rank >= 0)) {
#line 192 "../lib/chess-state.vala"
					break;
#line 1142 "chess-state.c"
				}
#line 194 "../lib/chess-state.vala"
				skip_count = 0;
#line 1146 "chess-state.c"
				{
					gint file = 0;
#line 195 "../lib/chess-state.vala"
					file = 0;
#line 1151 "chess-state.c"
					{
						gboolean _tmp3_ = FALSE;
#line 195 "../lib/chess-state.vala"
						_tmp3_ = TRUE;
#line 195 "../lib/chess-state.vala"
						while (TRUE) {
#line 1158 "chess-state.c"
							ChessPiece* p = NULL;
							ChessPiece* _tmp5_;
							ChessPiece* _tmp6_;
							ChessPiece* _tmp7_;
#line 195 "../lib/chess-state.vala"
							if (!_tmp3_) {
#line 1165 "chess-state.c"
								gint _tmp4_;
#line 195 "../lib/chess-state.vala"
								_tmp4_ = file;
#line 195 "../lib/chess-state.vala"
								file = _tmp4_ + 1;
#line 1171 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_tmp3_ = FALSE;
#line 195 "../lib/chess-state.vala"
							if (!(file < 8)) {
#line 195 "../lib/chess-state.vala"
								break;
#line 1179 "chess-state.c"
							}
#line 197 "../lib/chess-state.vala"
							_tmp5_ = self->board[chess_state_get_index (self, rank, file)];
#line 197 "../lib/chess-state.vala"
							_tmp6_ = _g_object_ref0 (_tmp5_);
#line 197 "../lib/chess-state.vala"
							p = _tmp6_;
#line 198 "../lib/chess-state.vala"
							_tmp7_ = p;
#line 198 "../lib/chess-state.vala"
							if (_tmp7_ == NULL) {
#line 1191 "chess-state.c"
								gint _tmp8_;
#line 199 "../lib/chess-state.vala"
								_tmp8_ = skip_count;
#line 199 "../lib/chess-state.vala"
								skip_count = _tmp8_ + 1;
#line 1197 "chess-state.c"
							} else {
								GString* _tmp10_;
								ChessPiece* _tmp11_;
								gunichar _tmp12_;
								gunichar _tmp13_;
#line 202 "../lib/chess-state.vala"
								if (skip_count > 0) {
#line 1205 "chess-state.c"
									GString* _tmp9_;
#line 204 "../lib/chess-state.vala"
									_tmp9_ = value;
#line 204 "../lib/chess-state.vala"
									g_string_append_printf (_tmp9_, "%d", skip_count);
#line 205 "../lib/chess-state.vala"
									skip_count = 0;
#line 1213 "chess-state.c"
								}
#line 207 "../lib/chess-state.vala"
								_tmp10_ = value;
#line 207 "../lib/chess-state.vala"
								_tmp11_ = p;
#line 207 "../lib/chess-state.vala"
								_tmp12_ = chess_piece_get_symbol (_tmp11_);
#line 207 "../lib/chess-state.vala"
								_tmp13_ = _tmp12_;
#line 207 "../lib/chess-state.vala"
								g_string_append_printf (_tmp10_, "%c", (gint) _tmp13_);
#line 1225 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 1229 "chess-state.c"
						}
					}
				}
#line 210 "../lib/chess-state.vala"
				if (skip_count > 0) {
#line 1235 "chess-state.c"
					GString* _tmp14_;
#line 211 "../lib/chess-state.vala"
					_tmp14_ = value;
#line 211 "../lib/chess-state.vala"
					g_string_append_printf (_tmp14_, "%d", skip_count);
#line 1241 "chess-state.c"
				}
#line 212 "../lib/chess-state.vala"
				if (rank != 0) {
#line 1245 "chess-state.c"
					GString* _tmp15_;
#line 213 "../lib/chess-state.vala"
					_tmp15_ = value;
#line 213 "../lib/chess-state.vala"
					g_string_append_c (_tmp15_, '/');
#line 1251 "chess-state.c"
				}
			}
		}
	}
#line 216 "../lib/chess-state.vala"
	_tmp16_ = value;
#line 216 "../lib/chess-state.vala"
	g_string_append_c (_tmp16_, ' ');
#line 217 "../lib/chess-state.vala"
	_tmp17_ = self->current_player;
#line 217 "../lib/chess-state.vala"
	if (_tmp17_->color == COLOR_WHITE) {
#line 1264 "chess-state.c"
		GString* _tmp18_;
#line 218 "../lib/chess-state.vala"
		_tmp18_ = value;
#line 218 "../lib/chess-state.vala"
		g_string_append_c (_tmp18_, 'w');
#line 1270 "chess-state.c"
	} else {
		GString* _tmp19_;
#line 220 "../lib/chess-state.vala"
		_tmp19_ = value;
#line 220 "../lib/chess-state.vala"
		g_string_append_c (_tmp19_, 'b');
#line 1277 "chess-state.c"
	}
#line 222 "../lib/chess-state.vala"
	_tmp20_ = value;
#line 222 "../lib/chess-state.vala"
	g_string_append_c (_tmp20_, ' ');
#line 223 "../lib/chess-state.vala"
	_tmp21_ = self->can_castle_kingside[COLOR_WHITE];
#line 223 "../lib/chess-state.vala"
	if (_tmp21_) {
#line 1287 "chess-state.c"
		GString* _tmp22_;
#line 224 "../lib/chess-state.vala"
		_tmp22_ = value;
#line 224 "../lib/chess-state.vala"
		g_string_append_c (_tmp22_, 'K');
#line 1293 "chess-state.c"
	}
#line 225 "../lib/chess-state.vala"
	_tmp23_ = self->can_castle_queenside[COLOR_WHITE];
#line 225 "../lib/chess-state.vala"
	if (_tmp23_) {
#line 1299 "chess-state.c"
		GString* _tmp24_;
#line 226 "../lib/chess-state.vala"
		_tmp24_ = value;
#line 226 "../lib/chess-state.vala"
		g_string_append_c (_tmp24_, 'Q');
#line 1305 "chess-state.c"
	}
#line 227 "../lib/chess-state.vala"
	_tmp25_ = self->can_castle_kingside[COLOR_BLACK];
#line 227 "../lib/chess-state.vala"
	if (_tmp25_) {
#line 1311 "chess-state.c"
		GString* _tmp26_;
#line 228 "../lib/chess-state.vala"
		_tmp26_ = value;
#line 228 "../lib/chess-state.vala"
		g_string_append_c (_tmp26_, 'k');
#line 1317 "chess-state.c"
	}
#line 229 "../lib/chess-state.vala"
	_tmp27_ = self->can_castle_queenside[COLOR_BLACK];
#line 229 "../lib/chess-state.vala"
	if (_tmp27_) {
#line 1323 "chess-state.c"
		GString* _tmp28_;
#line 230 "../lib/chess-state.vala"
		_tmp28_ = value;
#line 230 "../lib/chess-state.vala"
		g_string_append_c (_tmp28_, 'q');
#line 1329 "chess-state.c"
	}
#line 231 "../lib/chess-state.vala"
	_tmp29_ = self->can_castle_kingside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp30_ = self->can_castle_queenside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp31_ = self->can_castle_kingside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	_tmp32_ = self->can_castle_queenside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	if (!(((_tmp29_ | _tmp30_) | _tmp31_) | _tmp32_)) {
#line 1341 "chess-state.c"
		GString* _tmp33_;
#line 232 "../lib/chess-state.vala"
		_tmp33_ = value;
#line 232 "../lib/chess-state.vala"
		g_string_append_c (_tmp33_, '-');
#line 1347 "chess-state.c"
	}
#line 234 "../lib/chess-state.vala"
	_tmp34_ = value;
#line 234 "../lib/chess-state.vala"
	g_string_append_c (_tmp34_, ' ');
#line 235 "../lib/chess-state.vala"
	if (self->en_passant_index >= 0) {
#line 1355 "chess-state.c"
		GString* _tmp35_;
#line 236 "../lib/chess-state.vala"
		_tmp35_ = value;
#line 236 "../lib/chess-state.vala"
		g_string_append_printf (_tmp35_, "%c%d", 'a' + chess_state_get_file (self, self->en_passant_index), chess_state_get_rank (self, self->en_passant_index) + 1);
#line 1361 "chess-state.c"
	} else {
		GString* _tmp36_;
#line 238 "../lib/chess-state.vala"
		_tmp36_ = value;
#line 238 "../lib/chess-state.vala"
		g_string_append_c (_tmp36_, '-');
#line 1368 "chess-state.c"
	}
#line 240 "../lib/chess-state.vala"
	_tmp37_ = value;
#line 240 "../lib/chess-state.vala"
	g_string_append_c (_tmp37_, ' ');
#line 241 "../lib/chess-state.vala"
	_tmp38_ = value;
#line 241 "../lib/chess-state.vala"
	g_string_append_printf (_tmp38_, "%d", self->halfmove_clock);
#line 243 "../lib/chess-state.vala"
	_tmp39_ = value;
#line 243 "../lib/chess-state.vala"
	g_string_append_c (_tmp39_, ' ');
#line 244 "../lib/chess-state.vala"
	_tmp40_ = self->current_player;
#line 244 "../lib/chess-state.vala"
	if (_tmp40_->color == COLOR_WHITE) {
#line 1386 "chess-state.c"
		GString* _tmp41_;
#line 245 "../lib/chess-state.vala"
		_tmp41_ = value;
#line 245 "../lib/chess-state.vala"
		g_string_append_printf (_tmp41_, "%d", self->number / 2);
#line 1392 "chess-state.c"
	} else {
		GString* _tmp42_;
#line 247 "../lib/chess-state.vala"
		_tmp42_ = value;
#line 247 "../lib/chess-state.vala"
		g_string_append_printf (_tmp42_, "%d", (self->number / 2) + 1);
#line 1399 "chess-state.c"
	}
#line 249 "../lib/chess-state.vala"
	_tmp43_ = value;
#line 249 "../lib/chess-state.vala"
	_tmp44_ = _tmp43_->str;
#line 249 "../lib/chess-state.vala"
	_tmp45_ = g_strdup (_tmp44_);
#line 249 "../lib/chess-state.vala"
	result = _tmp45_;
#line 249 "../lib/chess-state.vala"
	_g_string_free0 (value);
#line 249 "../lib/chess-state.vala"
	return result;
#line 1413 "chess-state.c"
}

gint
chess_state_get_index (ChessState* self,
                       gint rank,
                       gint file)
{
	gint result;
#line 252 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 254 "../lib/chess-state.vala"
	result = (rank * 8) + file;
#line 254 "../lib/chess-state.vala"
	return result;
#line 1428 "chess-state.c"
}

gint
chess_state_get_rank (ChessState* self,
                      gint index)
{
	gint result;
#line 257 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 259 "../lib/chess-state.vala"
	result = index / 8;
#line 259 "../lib/chess-state.vala"
	return result;
#line 1442 "chess-state.c"
}

gint
chess_state_get_file (ChessState* self,
                      gint index)
{
	gint result;
#line 262 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 264 "../lib/chess-state.vala"
	result = index % 8;
#line 264 "../lib/chess-state.vala"
	return result;
#line 1456 "chess-state.c"
}

gboolean
chess_state_move (ChessState* self,
                  const gchar* move,
                  gboolean apply)
{
	gint r0 = 0;
	gint f0 = 0;
	gint r1 = 0;
	gint f1 = 0;
	PieceType promotion_type = 0;
	ChessPlayer* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	PieceType _tmp5_ = 0;
	gboolean _tmp6_;
	ChessPlayer* _tmp7_;
	gboolean result;
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 272 "../lib/chess-state.vala"
	_tmp0_ = self->current_player;
#line 272 "../lib/chess-state.vala"
	_tmp6_ = chess_state_decode_move (self, _tmp0_, move, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 272 "../lib/chess-state.vala"
	r0 = _tmp1_;
#line 272 "../lib/chess-state.vala"
	f0 = _tmp2_;
#line 272 "../lib/chess-state.vala"
	r1 = _tmp3_;
#line 272 "../lib/chess-state.vala"
	f1 = _tmp4_;
#line 272 "../lib/chess-state.vala"
	promotion_type = _tmp5_;
#line 272 "../lib/chess-state.vala"
	if (!_tmp6_) {
#line 273 "../lib/chess-state.vala"
		result = FALSE;
#line 273 "../lib/chess-state.vala"
		return result;
#line 1502 "chess-state.c"
	}
#line 275 "../lib/chess-state.vala"
	_tmp7_ = self->current_player;
#line 275 "../lib/chess-state.vala"
	if (!chess_state_move_with_coords (self, _tmp7_, r0, f0, r1, f1, promotion_type, apply, TRUE)) {
#line 276 "../lib/chess-state.vala"
		result = FALSE;
#line 276 "../lib/chess-state.vala"
		return result;
#line 1512 "chess-state.c"
	}
#line 278 "../lib/chess-state.vala"
	result = TRUE;
#line 278 "../lib/chess-state.vala"
	return result;
#line 1518 "chess-state.c"
}

gboolean
chess_state_move_with_coords (ChessState* self,
                              ChessPlayer* player,
                              gint r0,
                              gint f0,
                              gint r1,
                              gint f1,
                              PieceType promotion_type,
                              gboolean apply,
                              gboolean test_check)
{
	gint start = 0;
	gint end = 0;
	Color color = 0;
	Color _tmp0_ = 0;
	Color opponent_color = 0;
	ChessPiece* piece = NULL;
	ChessPiece* _tmp1_;
	ChessPiece* _tmp2_;
	gboolean _tmp3_ = FALSE;
	ChessPiece* _tmp4_;
	gint64 end_mask = 0LL;
	gint64 _tmp7_;
	gint64 move_mask = 0LL;
	ChessPiece* _tmp8_;
	gint64 _tmp9_;
	gint64 over_mask = 0LL;
	gint64 _tmp10_;
	gint64 _tmp11_;
	gint64 _tmp12_;
	ChessPiece* victim = NULL;
	ChessPiece* _tmp13_;
	ChessPiece* _tmp14_;
	gint victim_index = 0;
	gboolean _tmp15_ = FALSE;
	ChessPiece* _tmp16_;
	gint rook_start = 0;
	gint rook_end = 0;
	gboolean is_promotion = FALSE;
	gboolean en_passant = FALSE;
	gboolean ambiguous_rank = FALSE;
	gboolean ambiguous_file = FALSE;
	ChessPiece* _tmp19_;
	gboolean _tmp45_ = FALSE;
	gint64 old_white_mask = 0LL;
	gint64 _tmp57_;
	gint64 old_black_mask = 0LL;
	gint64 _tmp58_;
	gboolean old_white_can_castle_kingside = FALSE;
	gboolean _tmp59_;
	gboolean old_white_can_castle_queenside = FALSE;
	gboolean _tmp60_;
	gboolean old_black_can_castle_kingside = FALSE;
	gboolean _tmp61_;
	gboolean old_black_can_castle_queenside = FALSE;
	gboolean _tmp62_;
	gint old_en_passant_index = 0;
	gint old_halfmove_clock = 0;
	gint64 _tmp63_;
	gint64 _tmp64_;
	ChessPiece* _tmp65_;
	gint64 _tmp71_;
	ChessPiece* _tmp78_;
	gboolean _tmp85_ = FALSE;
	ChessPiece* _tmp86_;
	gboolean _tmp87_ = FALSE;
	ChessPiece* _tmp88_;
	gboolean _result_ = FALSE;
	gboolean _tmp91_ = FALSE;
	gboolean _tmp92_ = FALSE;
	ChessPlayer* _tmp102_ = NULL;
	ChessPlayer* _tmp105_;
	ChessPlayer* _tmp106_;
	ChessMove* _tmp107_;
	ChessMove* _tmp108_;
	ChessMove* _tmp109_;
	ChessPiece* _tmp110_;
	ChessPiece* _tmp111_;
	ChessMove* _tmp115_;
	ChessPiece* _tmp116_;
	ChessPiece* _tmp117_;
	ChessMove* _tmp121_;
	ChessMove* _tmp122_;
	ChessMove* _tmp123_;
	ChessMove* _tmp124_;
	ChessMove* _tmp125_;
	ChessMove* _tmp126_;
	ChessMove* _tmp127_;
	ChessMove* _tmp128_;
	gboolean result;
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 287 "../lib/chess-state.vala"
	start = chess_state_get_index (self, r0, f0);
#line 288 "../lib/chess-state.vala"
	end = chess_state_get_index (self, r1, f1);
#line 290 "../lib/chess-state.vala"
	color = player->color;
#line 291 "../lib/chess-state.vala"
	if (color == COLOR_WHITE) {
#line 291 "../lib/chess-state.vala"
		_tmp0_ = COLOR_BLACK;
#line 1625 "chess-state.c"
	} else {
#line 291 "../lib/chess-state.vala"
		_tmp0_ = COLOR_WHITE;
#line 1629 "chess-state.c"
	}
#line 291 "../lib/chess-state.vala"
	opponent_color = _tmp0_;
#line 294 "../lib/chess-state.vala"
	_tmp1_ = self->board[start];
#line 294 "../lib/chess-state.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 294 "../lib/chess-state.vala"
	piece = _tmp2_;
#line 295 "../lib/chess-state.vala"
	_tmp4_ = piece;
#line 295 "../lib/chess-state.vala"
	if (_tmp4_ == NULL) {
#line 295 "../lib/chess-state.vala"
		_tmp3_ = TRUE;
#line 1645 "chess-state.c"
	} else {
		ChessPiece* _tmp5_;
		ChessPlayer* _tmp6_;
#line 295 "../lib/chess-state.vala"
		_tmp5_ = piece;
#line 295 "../lib/chess-state.vala"
		_tmp6_ = _tmp5_->player;
#line 295 "../lib/chess-state.vala"
		_tmp3_ = _tmp6_ != player;
#line 1655 "chess-state.c"
	}
#line 295 "../lib/chess-state.vala"
	if (_tmp3_) {
#line 296 "../lib/chess-state.vala"
		result = FALSE;
#line 296 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 296 "../lib/chess-state.vala"
		return result;
#line 1665 "chess-state.c"
	}
#line 299 "../lib/chess-state.vala"
	_tmp7_ = BIT_BOARD_set_location_masks[end];
#line 299 "../lib/chess-state.vala"
	end_mask = _tmp7_;
#line 300 "../lib/chess-state.vala"
	_tmp8_ = piece;
#line 300 "../lib/chess-state.vala"
	_tmp9_ = BIT_BOARD_move_masks[(((color * 64) * 6) + (_tmp8_->type * 64)) + start];
#line 300 "../lib/chess-state.vala"
	move_mask = _tmp9_;
#line 301 "../lib/chess-state.vala"
	if ((end_mask & move_mask) == ((gint64) 0)) {
#line 302 "../lib/chess-state.vala"
		result = FALSE;
#line 302 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 302 "../lib/chess-state.vala"
		return result;
#line 1685 "chess-state.c"
	}
#line 305 "../lib/chess-state.vala"
	_tmp10_ = BIT_BOARD_over_masks[(start * 64) + end];
#line 305 "../lib/chess-state.vala"
	over_mask = _tmp10_;
#line 306 "../lib/chess-state.vala"
	_tmp11_ = self->priv->piece_masks[COLOR_WHITE];
#line 306 "../lib/chess-state.vala"
	_tmp12_ = self->priv->piece_masks[COLOR_BLACK];
#line 306 "../lib/chess-state.vala"
	if ((over_mask & (_tmp11_ | _tmp12_)) != ((gint64) 0)) {
#line 307 "../lib/chess-state.vala"
		result = FALSE;
#line 307 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 307 "../lib/chess-state.vala"
		return result;
#line 1703 "chess-state.c"
	}
#line 310 "../lib/chess-state.vala"
	_tmp13_ = self->board[end];
#line 310 "../lib/chess-state.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 310 "../lib/chess-state.vala"
	victim = _tmp14_;
#line 311 "../lib/chess-state.vala"
	victim_index = end;
#line 314 "../lib/chess-state.vala"
	_tmp16_ = victim;
#line 314 "../lib/chess-state.vala"
	if (_tmp16_ != NULL) {
#line 1717 "chess-state.c"
		ChessPiece* _tmp17_;
		ChessPlayer* _tmp18_;
#line 314 "../lib/chess-state.vala"
		_tmp17_ = victim;
#line 314 "../lib/chess-state.vala"
		_tmp18_ = _tmp17_->player;
#line 314 "../lib/chess-state.vala"
		_tmp15_ = _tmp18_ == player;
#line 1726 "chess-state.c"
	} else {
#line 314 "../lib/chess-state.vala"
		_tmp15_ = FALSE;
#line 1730 "chess-state.c"
	}
#line 314 "../lib/chess-state.vala"
	if (_tmp15_) {
#line 315 "../lib/chess-state.vala"
		result = FALSE;
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 315 "../lib/chess-state.vala"
		return result;
#line 1742 "chess-state.c"
	}
#line 318 "../lib/chess-state.vala"
	rook_start = -1;
#line 318 "../lib/chess-state.vala"
	rook_end = -1;
#line 319 "../lib/chess-state.vala"
	is_promotion = FALSE;
#line 320 "../lib/chess-state.vala"
	en_passant = FALSE;
#line 321 "../lib/chess-state.vala"
	ambiguous_rank = FALSE;
#line 322 "../lib/chess-state.vala"
	ambiguous_file = FALSE;
#line 323 "../lib/chess-state.vala"
	_tmp19_ = piece;
#line 323 "../lib/chess-state.vala"
	switch (_tmp19_->type) {
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_PAWN:
#line 1762 "chess-state.c"
		{
			gboolean _tmp20_ = FALSE;
			ChessPiece* _tmp21_;
			gboolean _tmp27_ = FALSE;
			ChessPiece* _tmp28_;
#line 327 "../lib/chess-state.vala"
			_tmp21_ = victim;
#line 327 "../lib/chess-state.vala"
			if (_tmp21_ == NULL) {
#line 327 "../lib/chess-state.vala"
				_tmp20_ = end == self->en_passant_index;
#line 1774 "chess-state.c"
			} else {
#line 327 "../lib/chess-state.vala"
				_tmp20_ = FALSE;
#line 1778 "chess-state.c"
			}
#line 327 "../lib/chess-state.vala"
			if (_tmp20_) {
#line 1782 "chess-state.c"
				gint _tmp22_ = 0;
				ChessPiece* _tmp23_;
				ChessPiece* _tmp24_;
#line 329 "../lib/chess-state.vala"
				en_passant = TRUE;
#line 330 "../lib/chess-state.vala"
				if (r1 == 2) {
#line 330 "../lib/chess-state.vala"
					_tmp22_ = 3;
#line 1792 "chess-state.c"
				} else {
#line 330 "../lib/chess-state.vala"
					_tmp22_ = 4;
#line 1796 "chess-state.c"
				}
#line 330 "../lib/chess-state.vala"
				victim_index = chess_state_get_index (self, _tmp22_, f1);
#line 331 "../lib/chess-state.vala"
				_tmp23_ = self->board[victim_index];
#line 331 "../lib/chess-state.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 331 "../lib/chess-state.vala"
				_g_object_unref0 (victim);
#line 331 "../lib/chess-state.vala"
				victim = _tmp24_;
#line 1808 "chess-state.c"
			}
#line 335 "../lib/chess-state.vala"
			if (f0 != f1) {
#line 1812 "chess-state.c"
				ChessPiece* _tmp25_;
#line 337 "../lib/chess-state.vala"
				_tmp25_ = victim;
#line 337 "../lib/chess-state.vala"
				if (_tmp25_ == NULL) {
#line 338 "../lib/chess-state.vala"
					result = FALSE;
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 338 "../lib/chess-state.vala"
					return result;
#line 1826 "chess-state.c"
				}
			} else {
				ChessPiece* _tmp26_;
#line 343 "../lib/chess-state.vala"
				_tmp26_ = victim;
#line 343 "../lib/chess-state.vala"
				if (_tmp26_ != NULL) {
#line 344 "../lib/chess-state.vala"
					result = FALSE;
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 344 "../lib/chess-state.vala"
					return result;
#line 1842 "chess-state.c"
				}
			}
#line 346 "../lib/chess-state.vala"
			if (r1 == 0) {
#line 346 "../lib/chess-state.vala"
				_tmp27_ = TRUE;
#line 1849 "chess-state.c"
			} else {
#line 346 "../lib/chess-state.vala"
				_tmp27_ = r1 == 7;
#line 1853 "chess-state.c"
			}
#line 346 "../lib/chess-state.vala"
			is_promotion = _tmp27_;
#line 349 "../lib/chess-state.vala"
			_tmp28_ = victim;
#line 349 "../lib/chess-state.vala"
			if (_tmp28_ != NULL) {
#line 350 "../lib/chess-state.vala"
				ambiguous_file = TRUE;
#line 1863 "chess-state.c"
			}
#line 351 "../lib/chess-state.vala"
			break;
#line 1867 "chess-state.c"
		}
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_KING:
#line 1871 "chess-state.c"
		{
#line 354 "../lib/chess-state.vala"
			if (abs (f0 - f1) > 1) {
#line 1875 "chess-state.c"
				gint _tmp29_ = 0;
				gint _tmp30_ = 0;
				ChessPiece* rook = NULL;
				ChessPiece* _tmp33_;
				ChessPiece* _tmp34_;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				ChessPiece* _tmp37_;
				gint64 rook_over_mask = 0LL;
				gint64 _tmp42_;
				gint64 _tmp43_;
				gint64 _tmp44_;
#line 357 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 357 "../lib/chess-state.vala"
					_tmp29_ = 7;
#line 1892 "chess-state.c"
				} else {
#line 357 "../lib/chess-state.vala"
					_tmp29_ = 0;
#line 1896 "chess-state.c"
				}
#line 357 "../lib/chess-state.vala"
				rook_start = chess_state_get_index (self, r0, _tmp29_);
#line 358 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 358 "../lib/chess-state.vala"
					_tmp30_ = f1 - 1;
#line 1904 "chess-state.c"
				} else {
#line 358 "../lib/chess-state.vala"
					_tmp30_ = f1 + 1;
#line 1908 "chess-state.c"
				}
#line 358 "../lib/chess-state.vala"
				rook_end = chess_state_get_index (self, r0, _tmp30_);
#line 361 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 1914 "chess-state.c"
					gboolean _tmp31_;
#line 363 "../lib/chess-state.vala"
					_tmp31_ = self->can_castle_kingside[color];
#line 363 "../lib/chess-state.vala"
					if (!_tmp31_) {
#line 364 "../lib/chess-state.vala"
						result = FALSE;
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 364 "../lib/chess-state.vala"
						return result;
#line 1928 "chess-state.c"
					}
				} else {
					gboolean _tmp32_;
#line 368 "../lib/chess-state.vala"
					_tmp32_ = self->can_castle_queenside[color];
#line 368 "../lib/chess-state.vala"
					if (!_tmp32_) {
#line 369 "../lib/chess-state.vala"
						result = FALSE;
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 369 "../lib/chess-state.vala"
						return result;
#line 1944 "chess-state.c"
					}
				}
#line 372 "../lib/chess-state.vala"
				_tmp33_ = self->board[rook_start];
#line 372 "../lib/chess-state.vala"
				_tmp34_ = _g_object_ref0 (_tmp33_);
#line 372 "../lib/chess-state.vala"
				rook = _tmp34_;
#line 373 "../lib/chess-state.vala"
				_tmp37_ = rook;
#line 373 "../lib/chess-state.vala"
				if (_tmp37_ == NULL) {
#line 373 "../lib/chess-state.vala"
					_tmp36_ = TRUE;
#line 1959 "chess-state.c"
				} else {
					ChessPiece* _tmp38_;
#line 373 "../lib/chess-state.vala"
					_tmp38_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp36_ = _tmp38_->type != PIECE_TYPE_ROOK;
#line 1966 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp36_) {
#line 373 "../lib/chess-state.vala"
					_tmp35_ = TRUE;
#line 1972 "chess-state.c"
				} else {
					ChessPiece* _tmp39_;
					Color _tmp40_;
					Color _tmp41_;
#line 373 "../lib/chess-state.vala"
					_tmp39_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp40_ = chess_piece_get_color (_tmp39_);
#line 373 "../lib/chess-state.vala"
					_tmp41_ = _tmp40_;
#line 373 "../lib/chess-state.vala"
					_tmp35_ = _tmp41_ != color;
#line 1985 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp35_) {
#line 374 "../lib/chess-state.vala"
					result = FALSE;
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 374 "../lib/chess-state.vala"
					return result;
#line 1999 "chess-state.c"
				}
#line 377 "../lib/chess-state.vala"
				_tmp42_ = BIT_BOARD_over_masks[(rook_start * 64) + rook_end];
#line 377 "../lib/chess-state.vala"
				rook_over_mask = _tmp42_;
#line 378 "../lib/chess-state.vala"
				_tmp43_ = self->priv->piece_masks[COLOR_WHITE];
#line 378 "../lib/chess-state.vala"
				_tmp44_ = self->priv->piece_masks[COLOR_BLACK];
#line 378 "../lib/chess-state.vala"
				if ((rook_over_mask & (_tmp43_ | _tmp44_)) != ((gint64) 0)) {
#line 379 "../lib/chess-state.vala"
					result = FALSE;
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 379 "../lib/chess-state.vala"
					return result;
#line 2021 "chess-state.c"
				}
#line 382 "../lib/chess-state.vala"
				if (self->check_state == CHECK_STATE_CHECK) {
#line 383 "../lib/chess-state.vala"
					result = FALSE;
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 383 "../lib/chess-state.vala"
					return result;
#line 2035 "chess-state.c"
				}
#line 386 "../lib/chess-state.vala"
				if (!chess_state_move_with_coords (self, player, r0, f0, chess_state_get_rank (self, rook_end), chess_state_get_file (self, rook_end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 387 "../lib/chess-state.vala"
					result = FALSE;
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 387 "../lib/chess-state.vala"
					return result;
#line 2049 "chess-state.c"
				}
#line 354 "../lib/chess-state.vala"
				_g_object_unref0 (rook);
#line 2053 "chess-state.c"
			}
#line 389 "../lib/chess-state.vala"
			break;
#line 2057 "chess-state.c"
		}
		default:
		{
#line 391 "../lib/chess-state.vala"
			break;
#line 2063 "chess-state.c"
		}
	}
#line 394 "../lib/chess-state.vala"
	if (!apply) {
#line 394 "../lib/chess-state.vala"
		_tmp45_ = !test_check;
#line 2070 "chess-state.c"
	} else {
#line 394 "../lib/chess-state.vala"
		_tmp45_ = FALSE;
#line 2074 "chess-state.c"
	}
#line 394 "../lib/chess-state.vala"
	if (_tmp45_) {
#line 395 "../lib/chess-state.vala"
		result = TRUE;
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 395 "../lib/chess-state.vala"
		return result;
#line 2086 "chess-state.c"
	}
#line 398 "../lib/chess-state.vala"
	if (apply) {
#line 2090 "chess-state.c"
		{
			gint i = 0;
#line 400 "../lib/chess-state.vala"
			i = 0;
#line 2095 "chess-state.c"
			{
				gboolean _tmp46_ = FALSE;
#line 400 "../lib/chess-state.vala"
				_tmp46_ = TRUE;
#line 400 "../lib/chess-state.vala"
				while (TRUE) {
#line 2102 "chess-state.c"
					ChessPiece* p = NULL;
					ChessPiece* _tmp48_;
					ChessPiece* _tmp49_;
					gboolean _tmp50_ = FALSE;
					gboolean _tmp51_ = FALSE;
					ChessPiece* _tmp52_;
					gint r = 0;
					gint f = 0;
#line 400 "../lib/chess-state.vala"
					if (!_tmp46_) {
#line 2113 "chess-state.c"
						gint _tmp47_;
#line 400 "../lib/chess-state.vala"
						_tmp47_ = i;
#line 400 "../lib/chess-state.vala"
						i = _tmp47_ + 1;
#line 2119 "chess-state.c"
					}
#line 400 "../lib/chess-state.vala"
					_tmp46_ = FALSE;
#line 400 "../lib/chess-state.vala"
					if (!(i < 64)) {
#line 400 "../lib/chess-state.vala"
						break;
#line 2127 "chess-state.c"
					}
#line 403 "../lib/chess-state.vala"
					if (i == start) {
#line 404 "../lib/chess-state.vala"
						continue;
#line 2133 "chess-state.c"
					}
#line 407 "../lib/chess-state.vala"
					_tmp48_ = self->board[i];
#line 407 "../lib/chess-state.vala"
					_tmp49_ = _g_object_ref0 (_tmp48_);
#line 407 "../lib/chess-state.vala"
					p = _tmp49_;
#line 408 "../lib/chess-state.vala"
					_tmp52_ = p;
#line 408 "../lib/chess-state.vala"
					if (_tmp52_ == NULL) {
#line 408 "../lib/chess-state.vala"
						_tmp51_ = TRUE;
#line 2147 "chess-state.c"
					} else {
						ChessPiece* _tmp53_;
						ChessPlayer* _tmp54_;
#line 408 "../lib/chess-state.vala"
						_tmp53_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp54_ = _tmp53_->player;
#line 408 "../lib/chess-state.vala"
						_tmp51_ = _tmp54_ != player;
#line 2157 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp51_) {
#line 408 "../lib/chess-state.vala"
						_tmp50_ = TRUE;
#line 2163 "chess-state.c"
					} else {
						ChessPiece* _tmp55_;
						ChessPiece* _tmp56_;
#line 408 "../lib/chess-state.vala"
						_tmp55_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp56_ = piece;
#line 408 "../lib/chess-state.vala"
						_tmp50_ = _tmp55_->type != _tmp56_->type;
#line 2173 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp50_) {
#line 409 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 409 "../lib/chess-state.vala"
						continue;
#line 2181 "chess-state.c"
					}
#line 412 "../lib/chess-state.vala"
					r = chess_state_get_rank (self, i);
#line 413 "../lib/chess-state.vala"
					f = chess_state_get_file (self, i);
#line 414 "../lib/chess-state.vala"
					if (chess_state_move_with_coords (self, player, r, f, r1, f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 416 "../lib/chess-state.vala"
						if (r != r0) {
#line 417 "../lib/chess-state.vala"
							ambiguous_rank = TRUE;
#line 2193 "chess-state.c"
						}
#line 418 "../lib/chess-state.vala"
						if (f != f0) {
#line 419 "../lib/chess-state.vala"
							ambiguous_file = TRUE;
#line 2199 "chess-state.c"
						}
					}
#line 400 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 2204 "chess-state.c"
				}
			}
		}
	}
#line 424 "../lib/chess-state.vala"
	_tmp57_ = self->priv->piece_masks[COLOR_WHITE];
#line 424 "../lib/chess-state.vala"
	old_white_mask = _tmp57_;
#line 425 "../lib/chess-state.vala"
	_tmp58_ = self->priv->piece_masks[COLOR_BLACK];
#line 425 "../lib/chess-state.vala"
	old_black_mask = _tmp58_;
#line 426 "../lib/chess-state.vala"
	_tmp59_ = self->can_castle_kingside[COLOR_WHITE];
#line 426 "../lib/chess-state.vala"
	old_white_can_castle_kingside = _tmp59_;
#line 427 "../lib/chess-state.vala"
	_tmp60_ = self->can_castle_queenside[COLOR_WHITE];
#line 427 "../lib/chess-state.vala"
	old_white_can_castle_queenside = _tmp60_;
#line 428 "../lib/chess-state.vala"
	_tmp61_ = self->can_castle_kingside[COLOR_BLACK];
#line 428 "../lib/chess-state.vala"
	old_black_can_castle_kingside = _tmp61_;
#line 429 "../lib/chess-state.vala"
	_tmp62_ = self->can_castle_queenside[COLOR_BLACK];
#line 429 "../lib/chess-state.vala"
	old_black_can_castle_queenside = _tmp62_;
#line 430 "../lib/chess-state.vala"
	old_en_passant_index = self->en_passant_index;
#line 431 "../lib/chess-state.vala"
	old_halfmove_clock = self->halfmove_clock;
#line 434 "../lib/chess-state.vala"
	_g_object_unref0 (self->board[start]);
#line 434 "../lib/chess-state.vala"
	self->board[start] = NULL;
#line 435 "../lib/chess-state.vala"
	_tmp63_ = BIT_BOARD_clear_location_masks[start];
#line 435 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_WHITE] &= _tmp63_;
#line 436 "../lib/chess-state.vala"
	_tmp64_ = BIT_BOARD_clear_location_masks[start];
#line 436 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_BLACK] &= _tmp64_;
#line 437 "../lib/chess-state.vala"
	_tmp65_ = victim;
#line 437 "../lib/chess-state.vala"
	if (_tmp65_ != NULL) {
#line 2253 "chess-state.c"
		gint64 _tmp66_;
		gint64 _tmp67_;
#line 439 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[victim_index]);
#line 439 "../lib/chess-state.vala"
		self->board[victim_index] = NULL;
#line 440 "../lib/chess-state.vala"
		_tmp66_ = BIT_BOARD_clear_location_masks[victim_index];
#line 440 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] &= _tmp66_;
#line 441 "../lib/chess-state.vala"
		_tmp67_ = BIT_BOARD_clear_location_masks[victim_index];
#line 441 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] &= _tmp67_;
#line 2268 "chess-state.c"
	}
#line 443 "../lib/chess-state.vala"
	if (is_promotion) {
#line 2272 "chess-state.c"
		ChessPiece* _tmp68_;
#line 444 "../lib/chess-state.vala"
		_tmp68_ = chess_piece_new (player, promotion_type);
#line 444 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[end]);
#line 444 "../lib/chess-state.vala"
		self->board[end] = _tmp68_;
#line 2280 "chess-state.c"
	} else {
		ChessPiece* _tmp69_;
		ChessPiece* _tmp70_;
#line 446 "../lib/chess-state.vala"
		_tmp69_ = piece;
#line 446 "../lib/chess-state.vala"
		_tmp70_ = _g_object_ref0 (_tmp69_);
#line 446 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[end]);
#line 446 "../lib/chess-state.vala"
		self->board[end] = _tmp70_;
#line 2292 "chess-state.c"
	}
#line 447 "../lib/chess-state.vala"
	self->priv->piece_masks[color] |= end_mask;
#line 448 "../lib/chess-state.vala"
	_tmp71_ = BIT_BOARD_clear_location_masks[end];
#line 448 "../lib/chess-state.vala"
	self->priv->piece_masks[opponent_color] &= _tmp71_;
#line 449 "../lib/chess-state.vala"
	if (rook_start >= 0) {
#line 2302 "chess-state.c"
		ChessPiece* rook = NULL;
		ChessPiece* _tmp72_;
		ChessPiece* _tmp73_;
		gint64 _tmp74_;
		ChessPiece* _tmp75_;
		ChessPiece* _tmp76_;
		gint64 _tmp77_;
#line 451 "../lib/chess-state.vala"
		_tmp72_ = self->board[rook_start];
#line 451 "../lib/chess-state.vala"
		_tmp73_ = _g_object_ref0 (_tmp72_);
#line 451 "../lib/chess-state.vala"
		rook = _tmp73_;
#line 452 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[rook_start]);
#line 452 "../lib/chess-state.vala"
		self->board[rook_start] = NULL;
#line 453 "../lib/chess-state.vala"
		_tmp74_ = BIT_BOARD_clear_location_masks[rook_start];
#line 453 "../lib/chess-state.vala"
		self->priv->piece_masks[color] &= _tmp74_;
#line 454 "../lib/chess-state.vala"
		_tmp75_ = rook;
#line 454 "../lib/chess-state.vala"
		_tmp76_ = _g_object_ref0 (_tmp75_);
#line 454 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[rook_end]);
#line 454 "../lib/chess-state.vala"
		self->board[rook_end] = _tmp76_;
#line 455 "../lib/chess-state.vala"
		_tmp77_ = BIT_BOARD_set_location_masks[rook_end];
#line 455 "../lib/chess-state.vala"
		self->priv->piece_masks[color] |= _tmp77_;
#line 449 "../lib/chess-state.vala"
		_g_object_unref0 (rook);
#line 2338 "chess-state.c"
	}
#line 459 "../lib/chess-state.vala"
	_tmp78_ = piece;
#line 459 "../lib/chess-state.vala"
	if (_tmp78_->type == PIECE_TYPE_KING) {
#line 461 "../lib/chess-state.vala"
		self->can_castle_kingside[color] = FALSE;
#line 462 "../lib/chess-state.vala"
		self->can_castle_queenside[color] = FALSE;
#line 2348 "chess-state.c"
	} else {
		ChessPiece* _tmp79_;
#line 465 "../lib/chess-state.vala"
		_tmp79_ = piece;
#line 465 "../lib/chess-state.vala"
		if (_tmp79_->type == PIECE_TYPE_ROOK) {
#line 2355 "chess-state.c"
			gint _tmp80_ = 0;
			gint base_rank = 0;
#line 467 "../lib/chess-state.vala"
			if (color == COLOR_WHITE) {
#line 467 "../lib/chess-state.vala"
				_tmp80_ = 0;
#line 2362 "chess-state.c"
			} else {
#line 467 "../lib/chess-state.vala"
				_tmp80_ = 7;
#line 2366 "chess-state.c"
			}
#line 467 "../lib/chess-state.vala"
			base_rank = _tmp80_;
#line 468 "../lib/chess-state.vala"
			if (r0 == base_rank) {
#line 470 "../lib/chess-state.vala"
				if (f0 == 0) {
#line 471 "../lib/chess-state.vala"
					self->can_castle_queenside[color] = FALSE;
#line 2376 "chess-state.c"
				} else {
#line 472 "../lib/chess-state.vala"
					if (f0 == 7) {
#line 473 "../lib/chess-state.vala"
						self->can_castle_kingside[color] = FALSE;
#line 2382 "chess-state.c"
					}
				}
			}
		} else {
			gboolean _tmp81_ = FALSE;
			ChessPiece* _tmp82_;
#line 477 "../lib/chess-state.vala"
			_tmp82_ = victim;
#line 477 "../lib/chess-state.vala"
			if (_tmp82_ != NULL) {
#line 2393 "chess-state.c"
				ChessPiece* _tmp83_;
#line 477 "../lib/chess-state.vala"
				_tmp83_ = victim;
#line 477 "../lib/chess-state.vala"
				_tmp81_ = _tmp83_->type == PIECE_TYPE_ROOK;
#line 2399 "chess-state.c"
			} else {
#line 477 "../lib/chess-state.vala"
				_tmp81_ = FALSE;
#line 2403 "chess-state.c"
			}
#line 477 "../lib/chess-state.vala"
			if (_tmp81_) {
#line 2407 "chess-state.c"
				gint _tmp84_ = 0;
				gint base_rank = 0;
#line 479 "../lib/chess-state.vala"
				if (opponent_color == COLOR_WHITE) {
#line 479 "../lib/chess-state.vala"
					_tmp84_ = 0;
#line 2414 "chess-state.c"
				} else {
#line 479 "../lib/chess-state.vala"
					_tmp84_ = 7;
#line 2418 "chess-state.c"
				}
#line 479 "../lib/chess-state.vala"
				base_rank = _tmp84_;
#line 480 "../lib/chess-state.vala"
				if (r1 == base_rank) {
#line 482 "../lib/chess-state.vala"
					if (f1 == 0) {
#line 483 "../lib/chess-state.vala"
						self->can_castle_queenside[opponent_color] = FALSE;
#line 2428 "chess-state.c"
					} else {
#line 484 "../lib/chess-state.vala"
						if (f1 == 7) {
#line 485 "../lib/chess-state.vala"
							self->can_castle_kingside[opponent_color] = FALSE;
#line 2434 "chess-state.c"
						}
					}
				}
			}
		}
	}
#line 490 "../lib/chess-state.vala"
	_tmp86_ = piece;
#line 490 "../lib/chess-state.vala"
	if (_tmp86_->type == PIECE_TYPE_PAWN) {
#line 490 "../lib/chess-state.vala"
		_tmp85_ = over_mask != ((gint64) 0);
#line 2447 "chess-state.c"
	} else {
#line 490 "../lib/chess-state.vala"
		_tmp85_ = FALSE;
#line 2451 "chess-state.c"
	}
#line 490 "../lib/chess-state.vala"
	if (_tmp85_) {
#line 491 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (r0 + r1) / 2, f0);
#line 2457 "chess-state.c"
	} else {
#line 493 "../lib/chess-state.vala"
		self->en_passant_index = -1;
#line 2461 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	_tmp88_ = piece;
#line 496 "../lib/chess-state.vala"
	if (_tmp88_->type == PIECE_TYPE_PAWN) {
#line 496 "../lib/chess-state.vala"
		_tmp87_ = TRUE;
#line 2469 "chess-state.c"
	} else {
		ChessPiece* _tmp89_;
#line 496 "../lib/chess-state.vala"
		_tmp89_ = victim;
#line 496 "../lib/chess-state.vala"
		_tmp87_ = _tmp89_ != NULL;
#line 2476 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	if (_tmp87_) {
#line 497 "../lib/chess-state.vala"
		self->halfmove_clock = 0;
#line 2482 "chess-state.c"
	} else {
		gint _tmp90_;
#line 499 "../lib/chess-state.vala"
		_tmp90_ = self->halfmove_clock;
#line 499 "../lib/chess-state.vala"
		self->halfmove_clock = _tmp90_ + 1;
#line 2489 "chess-state.c"
	}
#line 502 "../lib/chess-state.vala"
	_result_ = TRUE;
#line 503 "../lib/chess-state.vala"
	if (test_check) {
#line 503 "../lib/chess-state.vala"
		_tmp91_ = chess_state_is_in_check (self, player);
#line 2497 "chess-state.c"
	} else {
#line 503 "../lib/chess-state.vala"
		_tmp91_ = FALSE;
#line 2501 "chess-state.c"
	}
#line 503 "../lib/chess-state.vala"
	if (_tmp91_) {
#line 504 "../lib/chess-state.vala"
		_result_ = FALSE;
#line 2507 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (!apply) {
#line 507 "../lib/chess-state.vala"
		_tmp92_ = TRUE;
#line 2513 "chess-state.c"
	} else {
#line 507 "../lib/chess-state.vala"
		_tmp92_ = !_result_;
#line 2517 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (_tmp92_) {
#line 2521 "chess-state.c"
		ChessPiece* _tmp93_;
		ChessPiece* _tmp94_;
		ChessPiece* _tmp95_;
#line 509 "../lib/chess-state.vala"
		_tmp93_ = piece;
#line 509 "../lib/chess-state.vala"
		_tmp94_ = _g_object_ref0 (_tmp93_);
#line 509 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[start]);
#line 509 "../lib/chess-state.vala"
		self->board[start] = _tmp94_;
#line 510 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[end]);
#line 510 "../lib/chess-state.vala"
		self->board[end] = NULL;
#line 511 "../lib/chess-state.vala"
		_tmp95_ = victim;
#line 511 "../lib/chess-state.vala"
		if (_tmp95_ != NULL) {
#line 2541 "chess-state.c"
			ChessPiece* _tmp96_;
			ChessPiece* _tmp97_;
#line 512 "../lib/chess-state.vala"
			_tmp96_ = victim;
#line 512 "../lib/chess-state.vala"
			_tmp97_ = _g_object_ref0 (_tmp96_);
#line 512 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[victim_index]);
#line 512 "../lib/chess-state.vala"
			self->board[victim_index] = _tmp97_;
#line 2552 "chess-state.c"
		}
#line 513 "../lib/chess-state.vala"
		if (rook_start >= 0) {
#line 2556 "chess-state.c"
			ChessPiece* rook = NULL;
			ChessPiece* _tmp98_;
			ChessPiece* _tmp99_;
			ChessPiece* _tmp100_;
			ChessPiece* _tmp101_;
#line 515 "../lib/chess-state.vala"
			_tmp98_ = self->board[rook_end];
#line 515 "../lib/chess-state.vala"
			_tmp99_ = _g_object_ref0 (_tmp98_);
#line 515 "../lib/chess-state.vala"
			rook = _tmp99_;
#line 516 "../lib/chess-state.vala"
			_tmp100_ = rook;
#line 516 "../lib/chess-state.vala"
			_tmp101_ = _g_object_ref0 (_tmp100_);
#line 516 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[rook_start]);
#line 516 "../lib/chess-state.vala"
			self->board[rook_start] = _tmp101_;
#line 517 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[rook_end]);
#line 517 "../lib/chess-state.vala"
			self->board[rook_end] = NULL;
#line 513 "../lib/chess-state.vala"
			_g_object_unref0 (rook);
#line 2582 "chess-state.c"
		}
#line 519 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] = old_white_mask;
#line 520 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] = old_black_mask;
#line 521 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_WHITE] = old_white_can_castle_kingside;
#line 522 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_WHITE] = old_white_can_castle_queenside;
#line 523 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_BLACK] = old_black_can_castle_kingside;
#line 524 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_BLACK] = old_black_can_castle_queenside;
#line 525 "../lib/chess-state.vala"
		self->en_passant_index = old_en_passant_index;
#line 526 "../lib/chess-state.vala"
		self->halfmove_clock = old_halfmove_clock;
#line 528 "../lib/chess-state.vala"
		result = _result_;
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 528 "../lib/chess-state.vala"
		return result;
#line 2608 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	if (color == COLOR_WHITE) {
#line 2612 "chess-state.c"
		ChessPlayer* _tmp103_;
#line 531 "../lib/chess-state.vala"
		_tmp103_ = self->players[COLOR_BLACK];
#line 531 "../lib/chess-state.vala"
		_tmp102_ = _tmp103_;
#line 2618 "chess-state.c"
	} else {
		ChessPlayer* _tmp104_;
#line 531 "../lib/chess-state.vala"
		_tmp104_ = self->players[COLOR_WHITE];
#line 531 "../lib/chess-state.vala"
		_tmp102_ = _tmp104_;
#line 2625 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	_tmp105_ = _g_object_ref0 (_tmp102_);
#line 531 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 531 "../lib/chess-state.vala"
	self->current_player = _tmp105_;
#line 532 "../lib/chess-state.vala"
	_tmp106_ = self->current_player;
#line 532 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp106_);
#line 534 "../lib/chess-state.vala"
	_tmp107_ = chess_move_new ();
#line 534 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 534 "../lib/chess-state.vala"
	self->last_move = _tmp107_;
#line 535 "../lib/chess-state.vala"
	_tmp108_ = self->last_move;
#line 535 "../lib/chess-state.vala"
	_tmp108_->number = self->number;
#line 536 "../lib/chess-state.vala"
	_tmp109_ = self->last_move;
#line 536 "../lib/chess-state.vala"
	_tmp110_ = piece;
#line 536 "../lib/chess-state.vala"
	_tmp111_ = _g_object_ref0 (_tmp110_);
#line 536 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp109_->piece);
#line 536 "../lib/chess-state.vala"
	_tmp109_->piece = _tmp111_;
#line 537 "../lib/chess-state.vala"
	if (is_promotion) {
#line 2659 "chess-state.c"
		ChessMove* _tmp112_;
		ChessPiece* _tmp113_;
		ChessPiece* _tmp114_;
#line 538 "../lib/chess-state.vala"
		_tmp112_ = self->last_move;
#line 538 "../lib/chess-state.vala"
		_tmp113_ = self->board[end];
#line 538 "../lib/chess-state.vala"
		_tmp114_ = _g_object_ref0 (_tmp113_);
#line 538 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp112_->promotion_piece);
#line 538 "../lib/chess-state.vala"
		_tmp112_->promotion_piece = _tmp114_;
#line 2673 "chess-state.c"
	}
#line 539 "../lib/chess-state.vala"
	_tmp115_ = self->last_move;
#line 539 "../lib/chess-state.vala"
	_tmp116_ = victim;
#line 539 "../lib/chess-state.vala"
	_tmp117_ = _g_object_ref0 (_tmp116_);
#line 539 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp115_->victim);
#line 539 "../lib/chess-state.vala"
	_tmp115_->victim = _tmp117_;
#line 540 "../lib/chess-state.vala"
	if (rook_end >= 0) {
#line 2687 "chess-state.c"
		ChessMove* _tmp118_;
		ChessPiece* _tmp119_;
		ChessPiece* _tmp120_;
#line 541 "../lib/chess-state.vala"
		_tmp118_ = self->last_move;
#line 541 "../lib/chess-state.vala"
		_tmp119_ = self->board[rook_end];
#line 541 "../lib/chess-state.vala"
		_tmp120_ = _g_object_ref0 (_tmp119_);
#line 541 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp118_->castling_rook);
#line 541 "../lib/chess-state.vala"
		_tmp118_->castling_rook = _tmp120_;
#line 2701 "chess-state.c"
	}
#line 542 "../lib/chess-state.vala"
	_tmp121_ = self->last_move;
#line 542 "../lib/chess-state.vala"
	_tmp121_->r0 = r0;
#line 543 "../lib/chess-state.vala"
	_tmp122_ = self->last_move;
#line 543 "../lib/chess-state.vala"
	_tmp122_->f0 = f0;
#line 544 "../lib/chess-state.vala"
	_tmp123_ = self->last_move;
#line 544 "../lib/chess-state.vala"
	_tmp123_->r1 = r1;
#line 545 "../lib/chess-state.vala"
	_tmp124_ = self->last_move;
#line 545 "../lib/chess-state.vala"
	_tmp124_->f1 = f1;
#line 546 "../lib/chess-state.vala"
	_tmp125_ = self->last_move;
#line 546 "../lib/chess-state.vala"
	_tmp125_->ambiguous_rank = ambiguous_rank;
#line 547 "../lib/chess-state.vala"
	_tmp126_ = self->last_move;
#line 547 "../lib/chess-state.vala"
	_tmp126_->ambiguous_file = ambiguous_file;
#line 548 "../lib/chess-state.vala"
	_tmp127_ = self->last_move;
#line 548 "../lib/chess-state.vala"
	_tmp127_->en_passant = en_passant;
#line 549 "../lib/chess-state.vala"
	_tmp128_ = self->last_move;
#line 549 "../lib/chess-state.vala"
	_tmp128_->check_state = self->check_state;
#line 551 "../lib/chess-state.vala"
	result = TRUE;
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (victim);
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (piece);
#line 551 "../lib/chess-state.vala"
	return result;
#line 2743 "chess-state.c"
}

ChessResult
chess_state_get_result (ChessState* self,
                        ChessRule* rule)
{
	ChessRule _vala_rule = 0;
	ChessPlayer* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	ChessMove* _tmp4_;
	ChessResult result;
#line 554 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 556 "../lib/chess-state.vala"
	_vala_rule = CHESS_RULE_CHECKMATE;
#line 557 "../lib/chess-state.vala"
	if (self->check_state == CHECK_STATE_CHECKMATE) {
#line 2762 "chess-state.c"
		ChessPlayer* _tmp0_;
#line 559 "../lib/chess-state.vala"
		_tmp0_ = self->current_player;
#line 559 "../lib/chess-state.vala"
		if (_tmp0_->color == COLOR_WHITE) {
#line 561 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 562 "../lib/chess-state.vala"
			result = CHESS_RESULT_BLACK_WON;
#line 562 "../lib/chess-state.vala"
			if (rule) {
#line 562 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 2776 "chess-state.c"
			}
#line 562 "../lib/chess-state.vala"
			return result;
#line 2780 "chess-state.c"
		} else {
#line 566 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 567 "../lib/chess-state.vala"
			result = CHESS_RESULT_WHITE_WON;
#line 567 "../lib/chess-state.vala"
			if (rule) {
#line 567 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 2790 "chess-state.c"
			}
#line 567 "../lib/chess-state.vala"
			return result;
#line 2794 "chess-state.c"
		}
	}
#line 571 "../lib/chess-state.vala"
	_tmp1_ = self->current_player;
#line 571 "../lib/chess-state.vala"
	if (!chess_state_can_move (self, _tmp1_)) {
#line 573 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_STALEMATE;
#line 574 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 574 "../lib/chess-state.vala"
		if (rule) {
#line 574 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 2809 "chess-state.c"
		}
#line 574 "../lib/chess-state.vala"
		return result;
#line 2813 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	_tmp4_ = self->last_move;
#line 577 "../lib/chess-state.vala"
	if (_tmp4_ != NULL) {
#line 2819 "chess-state.c"
		ChessMove* _tmp5_;
		ChessPiece* _tmp6_;
#line 577 "../lib/chess-state.vala"
		_tmp5_ = self->last_move;
#line 577 "../lib/chess-state.vala"
		_tmp6_ = _tmp5_->victim;
#line 577 "../lib/chess-state.vala"
		_tmp3_ = _tmp6_ != NULL;
#line 2828 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp3_ = FALSE;
#line 2832 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp3_) {
#line 577 "../lib/chess-state.vala"
		_tmp2_ = !chess_state_have_sufficient_material (self);
#line 2838 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp2_ = FALSE;
#line 2842 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp2_) {
#line 579 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_INSUFFICIENT_MATERIAL;
#line 580 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 580 "../lib/chess-state.vala"
		if (rule) {
#line 580 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 2854 "chess-state.c"
		}
#line 580 "../lib/chess-state.vala"
		return result;
#line 2858 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	result = CHESS_RESULT_IN_PROGRESS;
#line 583 "../lib/chess-state.vala"
	if (rule) {
#line 583 "../lib/chess-state.vala"
		*rule = _vala_rule;
#line 2866 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	return result;
#line 2870 "chess-state.c"
}

static CheckState
chess_state_get_check_state (ChessState* self,
                             ChessPlayer* player)
{
	CheckState result;
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, 0);
#line 588 "../lib/chess-state.vala"
	if (chess_state_is_in_check (self, player)) {
#line 590 "../lib/chess-state.vala"
		if (chess_state_is_in_checkmate (self, player)) {
#line 591 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECKMATE;
#line 591 "../lib/chess-state.vala"
			return result;
#line 2890 "chess-state.c"
		} else {
#line 593 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECK;
#line 593 "../lib/chess-state.vala"
			return result;
#line 2896 "chess-state.c"
		}
	}
#line 595 "../lib/chess-state.vala"
	result = CHECK_STATE_NONE;
#line 595 "../lib/chess-state.vala"
	return result;
#line 2903 "chess-state.c"
}

gboolean
chess_state_is_in_check (ChessState* self,
                         ChessPlayer* player)
{
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* opponent = NULL;
	ChessPlayer* _tmp3_;
	gboolean result;
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 600 "../lib/chess-state.vala"
	if (player->color == COLOR_WHITE) {
#line 2920 "chess-state.c"
		ChessPlayer* _tmp1_;
#line 600 "../lib/chess-state.vala"
		_tmp1_ = self->players[COLOR_BLACK];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp1_;
#line 2926 "chess-state.c"
	} else {
		ChessPlayer* _tmp2_;
#line 600 "../lib/chess-state.vala"
		_tmp2_ = self->players[COLOR_WHITE];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp2_;
#line 2933 "chess-state.c"
	}
#line 600 "../lib/chess-state.vala"
	_tmp3_ = _g_object_ref0 (_tmp0_);
#line 600 "../lib/chess-state.vala"
	opponent = _tmp3_;
#line 2939 "chess-state.c"
	{
		gint king_index = 0;
#line 603 "../lib/chess-state.vala"
		king_index = 0;
#line 2944 "chess-state.c"
		{
			gboolean _tmp4_ = FALSE;
#line 603 "../lib/chess-state.vala"
			_tmp4_ = TRUE;
#line 603 "../lib/chess-state.vala"
			while (TRUE) {
#line 2951 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp6_;
				ChessPiece* _tmp7_;
				gboolean _tmp8_ = FALSE;
				gboolean _tmp9_ = FALSE;
				ChessPiece* _tmp10_;
#line 603 "../lib/chess-state.vala"
				if (!_tmp4_) {
#line 2960 "chess-state.c"
					gint _tmp5_;
#line 603 "../lib/chess-state.vala"
					_tmp5_ = king_index;
#line 603 "../lib/chess-state.vala"
					king_index = _tmp5_ + 1;
#line 2966 "chess-state.c"
				}
#line 603 "../lib/chess-state.vala"
				_tmp4_ = FALSE;
#line 603 "../lib/chess-state.vala"
				if (!(king_index < 64)) {
#line 603 "../lib/chess-state.vala"
					break;
#line 2974 "chess-state.c"
				}
#line 605 "../lib/chess-state.vala"
				_tmp6_ = self->board[king_index];
#line 605 "../lib/chess-state.vala"
				_tmp7_ = _g_object_ref0 (_tmp6_);
#line 605 "../lib/chess-state.vala"
				p = _tmp7_;
#line 606 "../lib/chess-state.vala"
				_tmp10_ = p;
#line 606 "../lib/chess-state.vala"
				if (_tmp10_ != NULL) {
#line 2986 "chess-state.c"
					ChessPiece* _tmp11_;
					ChessPlayer* _tmp12_;
#line 606 "../lib/chess-state.vala"
					_tmp11_ = p;
#line 606 "../lib/chess-state.vala"
					_tmp12_ = _tmp11_->player;
#line 606 "../lib/chess-state.vala"
					_tmp9_ = _tmp12_ == player;
#line 2995 "chess-state.c"
				} else {
#line 606 "../lib/chess-state.vala"
					_tmp9_ = FALSE;
#line 2999 "chess-state.c"
				}
#line 606 "../lib/chess-state.vala"
				if (_tmp9_) {
#line 3003 "chess-state.c"
					ChessPiece* _tmp13_;
#line 606 "../lib/chess-state.vala"
					_tmp13_ = p;
#line 606 "../lib/chess-state.vala"
					_tmp8_ = _tmp13_->type == PIECE_TYPE_KING;
#line 3009 "chess-state.c"
				} else {
#line 606 "../lib/chess-state.vala"
					_tmp8_ = FALSE;
#line 3013 "chess-state.c"
				}
#line 606 "../lib/chess-state.vala"
				if (_tmp8_) {
#line 3017 "chess-state.c"
					{
						gint start = 0;
#line 609 "../lib/chess-state.vala"
						start = 0;
#line 3022 "chess-state.c"
						{
							gboolean _tmp14_ = FALSE;
#line 609 "../lib/chess-state.vala"
							_tmp14_ = TRUE;
#line 609 "../lib/chess-state.vala"
							while (TRUE) {
#line 3029 "chess-state.c"
								ChessPlayer* _tmp16_;
#line 609 "../lib/chess-state.vala"
								if (!_tmp14_) {
#line 3033 "chess-state.c"
									gint _tmp15_;
#line 609 "../lib/chess-state.vala"
									_tmp15_ = start;
#line 609 "../lib/chess-state.vala"
									start = _tmp15_ + 1;
#line 3039 "chess-state.c"
								}
#line 609 "../lib/chess-state.vala"
								_tmp14_ = FALSE;
#line 609 "../lib/chess-state.vala"
								if (!(start < 64)) {
#line 609 "../lib/chess-state.vala"
									break;
#line 3047 "chess-state.c"
								}
#line 611 "../lib/chess-state.vala"
								_tmp16_ = opponent;
#line 611 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, _tmp16_, chess_state_get_rank (self, start), chess_state_get_file (self, start), chess_state_get_rank (self, king_index), chess_state_get_file (self, king_index), PIECE_TYPE_QUEEN, FALSE, FALSE)) {
#line 615 "../lib/chess-state.vala"
									result = TRUE;
#line 615 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 615 "../lib/chess-state.vala"
									_g_object_unref0 (opponent);
#line 615 "../lib/chess-state.vala"
									return result;
#line 3061 "chess-state.c"
								}
							}
						}
					}
				}
#line 603 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3069 "chess-state.c"
			}
		}
	}
#line 620 "../lib/chess-state.vala"
	result = FALSE;
#line 620 "../lib/chess-state.vala"
	_g_object_unref0 (opponent);
#line 620 "../lib/chess-state.vala"
	return result;
#line 3079 "chess-state.c"
}

static gboolean
chess_state_is_in_checkmate (ChessState* self,
                             ChessPlayer* player)
{
	gboolean result;
#line 623 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 623 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 3091 "chess-state.c"
	{
		gint piece_index = 0;
#line 626 "../lib/chess-state.vala"
		piece_index = 0;
#line 3096 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 626 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 626 "../lib/chess-state.vala"
			while (TRUE) {
#line 3103 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				gboolean _tmp4_ = FALSE;
				ChessPiece* _tmp5_;
#line 626 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3111 "chess-state.c"
					gint _tmp1_;
#line 626 "../lib/chess-state.vala"
					_tmp1_ = piece_index;
#line 626 "../lib/chess-state.vala"
					piece_index = _tmp1_ + 1;
#line 3117 "chess-state.c"
				}
#line 626 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 626 "../lib/chess-state.vala"
				if (!(piece_index < 64)) {
#line 626 "../lib/chess-state.vala"
					break;
#line 3125 "chess-state.c"
				}
#line 628 "../lib/chess-state.vala"
				_tmp2_ = self->board[piece_index];
#line 628 "../lib/chess-state.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 628 "../lib/chess-state.vala"
				p = _tmp3_;
#line 629 "../lib/chess-state.vala"
				_tmp5_ = p;
#line 629 "../lib/chess-state.vala"
				if (_tmp5_ != NULL) {
#line 3137 "chess-state.c"
					ChessPiece* _tmp6_;
					ChessPlayer* _tmp7_;
#line 629 "../lib/chess-state.vala"
					_tmp6_ = p;
#line 629 "../lib/chess-state.vala"
					_tmp7_ = _tmp6_->player;
#line 629 "../lib/chess-state.vala"
					_tmp4_ = _tmp7_ == player;
#line 3146 "chess-state.c"
				} else {
#line 629 "../lib/chess-state.vala"
					_tmp4_ = FALSE;
#line 3150 "chess-state.c"
				}
#line 629 "../lib/chess-state.vala"
				if (_tmp4_) {
#line 3154 "chess-state.c"
					{
						gint end = 0;
#line 631 "../lib/chess-state.vala"
						end = 0;
#line 3159 "chess-state.c"
						{
							gboolean _tmp8_ = FALSE;
#line 631 "../lib/chess-state.vala"
							_tmp8_ = TRUE;
#line 631 "../lib/chess-state.vala"
							while (TRUE) {
#line 631 "../lib/chess-state.vala"
								if (!_tmp8_) {
#line 3168 "chess-state.c"
									gint _tmp9_;
#line 631 "../lib/chess-state.vala"
									_tmp9_ = end;
#line 631 "../lib/chess-state.vala"
									end = _tmp9_ + 1;
#line 3174 "chess-state.c"
								}
#line 631 "../lib/chess-state.vala"
								_tmp8_ = FALSE;
#line 631 "../lib/chess-state.vala"
								if (!(end < 64)) {
#line 631 "../lib/chess-state.vala"
									break;
#line 3182 "chess-state.c"
								}
#line 633 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, piece_index), chess_state_get_file (self, piece_index), chess_state_get_rank (self, end), chess_state_get_file (self, end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 637 "../lib/chess-state.vala"
									result = FALSE;
#line 637 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 637 "../lib/chess-state.vala"
									return result;
#line 3192 "chess-state.c"
								}
							}
						}
					}
				}
#line 626 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3200 "chess-state.c"
			}
		}
	}
#line 642 "../lib/chess-state.vala"
	result = TRUE;
#line 642 "../lib/chess-state.vala"
	return result;
#line 3208 "chess-state.c"
}

gboolean
chess_state_can_move (ChessState* self,
                      ChessPlayer* player)
{
	gboolean have_pieces = FALSE;
	gboolean result;
#line 645 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 645 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 647 "../lib/chess-state.vala"
	have_pieces = FALSE;
#line 3223 "chess-state.c"
	{
		gint start = 0;
#line 649 "../lib/chess-state.vala"
		start = 0;
#line 3228 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 649 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 649 "../lib/chess-state.vala"
			while (TRUE) {
#line 3235 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				gboolean _tmp4_ = FALSE;
				ChessPiece* _tmp5_;
#line 649 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3243 "chess-state.c"
					gint _tmp1_;
#line 649 "../lib/chess-state.vala"
					_tmp1_ = start;
#line 649 "../lib/chess-state.vala"
					start = _tmp1_ + 1;
#line 3249 "chess-state.c"
				}
#line 649 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 649 "../lib/chess-state.vala"
				if (!(start < 64)) {
#line 649 "../lib/chess-state.vala"
					break;
#line 3257 "chess-state.c"
				}
#line 651 "../lib/chess-state.vala"
				_tmp2_ = self->board[start];
#line 651 "../lib/chess-state.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 651 "../lib/chess-state.vala"
				p = _tmp3_;
#line 652 "../lib/chess-state.vala"
				_tmp5_ = p;
#line 652 "../lib/chess-state.vala"
				if (_tmp5_ != NULL) {
#line 3269 "chess-state.c"
					ChessPiece* _tmp6_;
					ChessPlayer* _tmp7_;
#line 652 "../lib/chess-state.vala"
					_tmp6_ = p;
#line 652 "../lib/chess-state.vala"
					_tmp7_ = _tmp6_->player;
#line 652 "../lib/chess-state.vala"
					_tmp4_ = _tmp7_ == player;
#line 3278 "chess-state.c"
				} else {
#line 652 "../lib/chess-state.vala"
					_tmp4_ = FALSE;
#line 3282 "chess-state.c"
				}
#line 652 "../lib/chess-state.vala"
				if (_tmp4_) {
#line 654 "../lib/chess-state.vala"
					have_pieces = TRUE;
#line 3288 "chess-state.c"
					{
						gint end = 0;
#line 657 "../lib/chess-state.vala"
						end = 0;
#line 3293 "chess-state.c"
						{
							gboolean _tmp8_ = FALSE;
#line 657 "../lib/chess-state.vala"
							_tmp8_ = TRUE;
#line 657 "../lib/chess-state.vala"
							while (TRUE) {
#line 657 "../lib/chess-state.vala"
								if (!_tmp8_) {
#line 3302 "chess-state.c"
									gint _tmp9_;
#line 657 "../lib/chess-state.vala"
									_tmp9_ = end;
#line 657 "../lib/chess-state.vala"
									end = _tmp9_ + 1;
#line 3308 "chess-state.c"
								}
#line 657 "../lib/chess-state.vala"
								_tmp8_ = FALSE;
#line 657 "../lib/chess-state.vala"
								if (!(end < 64)) {
#line 657 "../lib/chess-state.vala"
									break;
#line 3316 "chess-state.c"
								}
#line 659 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, start), chess_state_get_file (self, start), chess_state_get_rank (self, end), chess_state_get_file (self, end), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 663 "../lib/chess-state.vala"
									result = TRUE;
#line 663 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 663 "../lib/chess-state.vala"
									return result;
#line 3326 "chess-state.c"
								}
							}
						}
					}
				}
#line 649 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3334 "chess-state.c"
			}
		}
	}
#line 669 "../lib/chess-state.vala"
	if (have_pieces) {
#line 670 "../lib/chess-state.vala"
		result = FALSE;
#line 670 "../lib/chess-state.vala"
		return result;
#line 3344 "chess-state.c"
	} else {
#line 672 "../lib/chess-state.vala"
		result = TRUE;
#line 672 "../lib/chess-state.vala"
		return result;
#line 3350 "chess-state.c"
	}
}

gboolean
chess_state_have_sufficient_material (ChessState* self)
{
	gint white_knight_count = 0;
	gint white_bishop_count = 0;
	gboolean white_bishop_on_white_square = FALSE;
	gboolean white_bishop_on_black_square = FALSE;
	gint black_knight_count = 0;
	gint black_bishop_count = 0;
	gboolean black_bishop_on_white_square = FALSE;
	gboolean black_bishop_on_black_square = FALSE;
	gboolean result;
#line 675 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 677 "../lib/chess-state.vala"
	white_knight_count = 0;
#line 678 "../lib/chess-state.vala"
	white_bishop_count = 0;
#line 679 "../lib/chess-state.vala"
	white_bishop_on_white_square = FALSE;
#line 680 "../lib/chess-state.vala"
	white_bishop_on_black_square = FALSE;
#line 681 "../lib/chess-state.vala"
	black_knight_count = 0;
#line 682 "../lib/chess-state.vala"
	black_bishop_count = 0;
#line 683 "../lib/chess-state.vala"
	black_bishop_on_white_square = FALSE;
#line 684 "../lib/chess-state.vala"
	black_bishop_on_black_square = FALSE;
#line 3384 "chess-state.c"
	{
		gint i = 0;
#line 686 "../lib/chess-state.vala"
		i = 0;
#line 3389 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 686 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 686 "../lib/chess-state.vala"
			while (TRUE) {
#line 3396 "chess-state.c"
				ChessPiece* p = NULL;
				ChessPiece* _tmp2_;
				ChessPiece* _tmp3_;
				ChessPiece* _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
				ChessPiece* _tmp10_;
				ChessPiece* _tmp16_;
				gboolean _tmp22_ = FALSE;
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_ = FALSE;
				gboolean _tmp25_ = FALSE;
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_ = FALSE;
				gboolean _tmp28_ = FALSE;
				gboolean _tmp29_ = FALSE;
				gboolean _tmp30_ = FALSE;
				gboolean _tmp31_ = FALSE;
#line 686 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3418 "chess-state.c"
					gint _tmp1_;
#line 686 "../lib/chess-state.vala"
					_tmp1_ = i;
#line 686 "../lib/chess-state.vala"
					i = _tmp1_ + 1;
#line 3424 "chess-state.c"
				}
#line 686 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 686 "../lib/chess-state.vala"
				if (!(i < 64)) {
#line 686 "../lib/chess-state.vala"
					break;
#line 3432 "chess-state.c"
				}
#line 688 "../lib/chess-state.vala"
				_tmp2_ = self->board[i];
#line 688 "../lib/chess-state.vala"
				_tmp3_ = _g_object_ref0 (_tmp2_);
#line 688 "../lib/chess-state.vala"
				p = _tmp3_;
#line 689 "../lib/chess-state.vala"
				_tmp4_ = p;
#line 689 "../lib/chess-state.vala"
				if (_tmp4_ == NULL) {
#line 690 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 690 "../lib/chess-state.vala"
					continue;
#line 3448 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				_tmp7_ = p;
#line 693 "../lib/chess-state.vala"
				if (_tmp7_->type == PIECE_TYPE_PAWN) {
#line 693 "../lib/chess-state.vala"
					_tmp6_ = TRUE;
#line 3456 "chess-state.c"
				} else {
					ChessPiece* _tmp8_;
#line 693 "../lib/chess-state.vala"
					_tmp8_ = p;
#line 693 "../lib/chess-state.vala"
					_tmp6_ = _tmp8_->type == PIECE_TYPE_ROOK;
#line 3463 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				if (_tmp6_) {
#line 693 "../lib/chess-state.vala"
					_tmp5_ = TRUE;
#line 3469 "chess-state.c"
				} else {
					ChessPiece* _tmp9_;
#line 693 "../lib/chess-state.vala"
					_tmp9_ = p;
#line 693 "../lib/chess-state.vala"
					_tmp5_ = _tmp9_->type == PIECE_TYPE_QUEEN;
#line 3476 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				if (_tmp5_) {
#line 694 "../lib/chess-state.vala"
					result = TRUE;
#line 694 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 694 "../lib/chess-state.vala"
					return result;
#line 3486 "chess-state.c"
				}
#line 697 "../lib/chess-state.vala"
				_tmp10_ = p;
#line 697 "../lib/chess-state.vala"
				if (_tmp10_->type == PIECE_TYPE_KNIGHT) {
#line 3492 "chess-state.c"
					ChessPiece* _tmp11_;
					Color _tmp12_;
					Color _tmp13_;
#line 699 "../lib/chess-state.vala"
					_tmp11_ = p;
#line 699 "../lib/chess-state.vala"
					_tmp12_ = chess_piece_get_color (_tmp11_);
#line 699 "../lib/chess-state.vala"
					_tmp13_ = _tmp12_;
#line 699 "../lib/chess-state.vala"
					if (_tmp13_ == COLOR_WHITE) {
#line 3504 "chess-state.c"
						gint _tmp14_;
#line 700 "../lib/chess-state.vala"
						_tmp14_ = white_knight_count;
#line 700 "../lib/chess-state.vala"
						white_knight_count = _tmp14_ + 1;
#line 3510 "chess-state.c"
					} else {
						gint _tmp15_;
#line 702 "../lib/chess-state.vala"
						_tmp15_ = black_knight_count;
#line 702 "../lib/chess-state.vala"
						black_knight_count = _tmp15_ + 1;
#line 3517 "chess-state.c"
					}
				}
#line 705 "../lib/chess-state.vala"
				_tmp16_ = p;
#line 705 "../lib/chess-state.vala"
				if (_tmp16_->type == PIECE_TYPE_BISHOP) {
#line 3524 "chess-state.c"
					Color color = 0;
					ChessPiece* _tmp17_;
					Color _tmp18_;
					Color _tmp19_;
#line 707 "../lib/chess-state.vala"
					color = COLOR_BLACK;
#line 708 "../lib/chess-state.vala"
					if (((i + (i / 8)) % 2) != 0) {
#line 709 "../lib/chess-state.vala"
						color = COLOR_WHITE;
#line 3535 "chess-state.c"
					}
#line 711 "../lib/chess-state.vala"
					_tmp17_ = p;
#line 711 "../lib/chess-state.vala"
					_tmp18_ = chess_piece_get_color (_tmp17_);
#line 711 "../lib/chess-state.vala"
					_tmp19_ = _tmp18_;
#line 711 "../lib/chess-state.vala"
					if (_tmp19_ == COLOR_WHITE) {
#line 3545 "chess-state.c"
						gint _tmp20_;
#line 713 "../lib/chess-state.vala"
						if (color == COLOR_WHITE) {
#line 714 "../lib/chess-state.vala"
							white_bishop_on_white_square = TRUE;
#line 3551 "chess-state.c"
						} else {
#line 716 "../lib/chess-state.vala"
							white_bishop_on_black_square = TRUE;
#line 3555 "chess-state.c"
						}
#line 717 "../lib/chess-state.vala"
						_tmp20_ = white_bishop_count;
#line 717 "../lib/chess-state.vala"
						white_bishop_count = _tmp20_ + 1;
#line 3561 "chess-state.c"
					} else {
						gint _tmp21_;
#line 721 "../lib/chess-state.vala"
						if (color == COLOR_WHITE) {
#line 722 "../lib/chess-state.vala"
							black_bishop_on_white_square = TRUE;
#line 3568 "chess-state.c"
						} else {
#line 724 "../lib/chess-state.vala"
							black_bishop_on_black_square = TRUE;
#line 3572 "chess-state.c"
						}
#line 725 "../lib/chess-state.vala"
						_tmp21_ = black_bishop_count;
#line 725 "../lib/chess-state.vala"
						black_bishop_count = _tmp21_ + 1;
#line 3578 "chess-state.c"
					}
				}
#line 759 "../lib/chess-state.vala"
				if (white_knight_count > 1) {
#line 759 "../lib/chess-state.vala"
					_tmp22_ = TRUE;
#line 3585 "chess-state.c"
				} else {
#line 759 "../lib/chess-state.vala"
					_tmp22_ = black_knight_count > 1;
#line 3589 "chess-state.c"
				}
#line 759 "../lib/chess-state.vala"
				if (_tmp22_) {
#line 760 "../lib/chess-state.vala"
					result = TRUE;
#line 760 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 760 "../lib/chess-state.vala"
					return result;
#line 3599 "chess-state.c"
				}
#line 763 "../lib/chess-state.vala"
				if (white_bishop_count > 0) {
#line 763 "../lib/chess-state.vala"
					_tmp23_ = white_knight_count > 0;
#line 3605 "chess-state.c"
				} else {
#line 763 "../lib/chess-state.vala"
					_tmp23_ = FALSE;
#line 3609 "chess-state.c"
				}
#line 763 "../lib/chess-state.vala"
				if (_tmp23_) {
#line 764 "../lib/chess-state.vala"
					result = TRUE;
#line 764 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 764 "../lib/chess-state.vala"
					return result;
#line 3619 "chess-state.c"
				}
#line 765 "../lib/chess-state.vala"
				if (black_bishop_count > 0) {
#line 765 "../lib/chess-state.vala"
					_tmp24_ = black_knight_count > 0;
#line 3625 "chess-state.c"
				} else {
#line 765 "../lib/chess-state.vala"
					_tmp24_ = FALSE;
#line 3629 "chess-state.c"
				}
#line 765 "../lib/chess-state.vala"
				if (_tmp24_) {
#line 766 "../lib/chess-state.vala"
					result = TRUE;
#line 766 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 766 "../lib/chess-state.vala"
					return result;
#line 3639 "chess-state.c"
				}
#line 769 "../lib/chess-state.vala"
				if (white_bishop_on_white_square) {
#line 769 "../lib/chess-state.vala"
					_tmp25_ = white_bishop_on_black_square;
#line 3645 "chess-state.c"
				} else {
#line 769 "../lib/chess-state.vala"
					_tmp25_ = FALSE;
#line 3649 "chess-state.c"
				}
#line 769 "../lib/chess-state.vala"
				if (_tmp25_) {
#line 770 "../lib/chess-state.vala"
					result = TRUE;
#line 770 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 770 "../lib/chess-state.vala"
					return result;
#line 3659 "chess-state.c"
				}
#line 771 "../lib/chess-state.vala"
				if (black_bishop_on_white_square) {
#line 771 "../lib/chess-state.vala"
					_tmp26_ = black_bishop_on_black_square;
#line 3665 "chess-state.c"
				} else {
#line 771 "../lib/chess-state.vala"
					_tmp26_ = FALSE;
#line 3669 "chess-state.c"
				}
#line 771 "../lib/chess-state.vala"
				if (_tmp26_) {
#line 772 "../lib/chess-state.vala"
					result = TRUE;
#line 772 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 772 "../lib/chess-state.vala"
					return result;
#line 3679 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (white_bishop_count > 0) {
#line 775 "../lib/chess-state.vala"
					_tmp28_ = TRUE;
#line 3685 "chess-state.c"
				} else {
#line 775 "../lib/chess-state.vala"
					_tmp28_ = white_knight_count > 0;
#line 3689 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (_tmp28_) {
#line 775 "../lib/chess-state.vala"
					_tmp27_ = black_knight_count > 0;
#line 3695 "chess-state.c"
				} else {
#line 775 "../lib/chess-state.vala"
					_tmp27_ = FALSE;
#line 3699 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (_tmp27_) {
#line 776 "../lib/chess-state.vala"
					result = TRUE;
#line 776 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 776 "../lib/chess-state.vala"
					return result;
#line 3709 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (black_bishop_count > 0) {
#line 777 "../lib/chess-state.vala"
					_tmp30_ = TRUE;
#line 3715 "chess-state.c"
				} else {
#line 777 "../lib/chess-state.vala"
					_tmp30_ = black_knight_count > 0;
#line 3719 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (_tmp30_) {
#line 777 "../lib/chess-state.vala"
					_tmp29_ = white_knight_count > 0;
#line 3725 "chess-state.c"
				} else {
#line 777 "../lib/chess-state.vala"
					_tmp29_ = FALSE;
#line 3729 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (_tmp29_) {
#line 778 "../lib/chess-state.vala"
					result = TRUE;
#line 778 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 778 "../lib/chess-state.vala"
					return result;
#line 3739 "chess-state.c"
				}
#line 781 "../lib/chess-state.vala"
				if (white_bishop_count > 0) {
#line 781 "../lib/chess-state.vala"
					_tmp31_ = black_bishop_count > 0;
#line 3745 "chess-state.c"
				} else {
#line 781 "../lib/chess-state.vala"
					_tmp31_ = FALSE;
#line 3749 "chess-state.c"
				}
#line 781 "../lib/chess-state.vala"
				if (_tmp31_) {
#line 3753 "chess-state.c"
					gboolean _tmp32_ = FALSE;
#line 783 "../lib/chess-state.vala"
					if (white_bishop_on_white_square) {
#line 783 "../lib/chess-state.vala"
						_tmp32_ = black_bishop_on_black_square;
#line 3759 "chess-state.c"
					} else {
#line 783 "../lib/chess-state.vala"
						_tmp32_ = FALSE;
#line 3763 "chess-state.c"
					}
#line 783 "../lib/chess-state.vala"
					if (_tmp32_) {
#line 784 "../lib/chess-state.vala"
						result = TRUE;
#line 784 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 784 "../lib/chess-state.vala"
						return result;
#line 3773 "chess-state.c"
					} else {
						gboolean _tmp33_ = FALSE;
#line 785 "../lib/chess-state.vala"
						if (white_bishop_on_black_square) {
#line 785 "../lib/chess-state.vala"
							_tmp33_ = black_bishop_on_white_square;
#line 3780 "chess-state.c"
						} else {
#line 785 "../lib/chess-state.vala"
							_tmp33_ = FALSE;
#line 3784 "chess-state.c"
						}
#line 785 "../lib/chess-state.vala"
						if (_tmp33_) {
#line 786 "../lib/chess-state.vala"
							result = TRUE;
#line 786 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 786 "../lib/chess-state.vala"
							return result;
#line 3794 "chess-state.c"
						}
					}
				}
#line 686 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3800 "chess-state.c"
			}
		}
	}
#line 790 "../lib/chess-state.vala"
	result = FALSE;
#line 790 "../lib/chess-state.vala"
	return result;
#line 3808 "chess-state.c"
}

static gboolean
chess_state_decode_piece_type (ChessState* self,
                               gunichar c,
                               PieceType* type)
{
	PieceType _vala_type = 0;
	gboolean result;
#line 793 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 795 "../lib/chess-state.vala"
	_vala_type = PIECE_TYPE_PAWN;
#line 796 "../lib/chess-state.vala"
	switch (c) {
#line 796 "../lib/chess-state.vala"
		case 'P':
#line 3826 "chess-state.c"
		{
#line 799 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_PAWN;
#line 800 "../lib/chess-state.vala"
			result = TRUE;
#line 800 "../lib/chess-state.vala"
			if (type) {
#line 800 "../lib/chess-state.vala"
				*type = _vala_type;
#line 3836 "chess-state.c"
			}
#line 800 "../lib/chess-state.vala"
			return result;
#line 3840 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'R':
#line 3844 "chess-state.c"
		{
#line 802 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_ROOK;
#line 803 "../lib/chess-state.vala"
			result = TRUE;
#line 803 "../lib/chess-state.vala"
			if (type) {
#line 803 "../lib/chess-state.vala"
				*type = _vala_type;
#line 3854 "chess-state.c"
			}
#line 803 "../lib/chess-state.vala"
			return result;
#line 3858 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'N':
#line 3862 "chess-state.c"
		{
#line 805 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KNIGHT;
#line 806 "../lib/chess-state.vala"
			result = TRUE;
#line 806 "../lib/chess-state.vala"
			if (type) {
#line 806 "../lib/chess-state.vala"
				*type = _vala_type;
#line 3872 "chess-state.c"
			}
#line 806 "../lib/chess-state.vala"
			return result;
#line 3876 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'B':
#line 3880 "chess-state.c"
		{
#line 808 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_BISHOP;
#line 809 "../lib/chess-state.vala"
			result = TRUE;
#line 809 "../lib/chess-state.vala"
			if (type) {
#line 809 "../lib/chess-state.vala"
				*type = _vala_type;
#line 3890 "chess-state.c"
			}
#line 809 "../lib/chess-state.vala"
			return result;
#line 3894 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'Q':
#line 3898 "chess-state.c"
		{
#line 811 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_QUEEN;
#line 812 "../lib/chess-state.vala"
			result = TRUE;
#line 812 "../lib/chess-state.vala"
			if (type) {
#line 812 "../lib/chess-state.vala"
				*type = _vala_type;
#line 3908 "chess-state.c"
			}
#line 812 "../lib/chess-state.vala"
			return result;
#line 3912 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'K':
#line 3916 "chess-state.c"
		{
#line 814 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KING;
#line 815 "../lib/chess-state.vala"
			result = TRUE;
#line 815 "../lib/chess-state.vala"
			if (type) {
#line 815 "../lib/chess-state.vala"
				*type = _vala_type;
#line 3926 "chess-state.c"
			}
#line 815 "../lib/chess-state.vala"
			return result;
#line 3930 "chess-state.c"
		}
		default:
		{
#line 817 "../lib/chess-state.vala"
			result = FALSE;
#line 817 "../lib/chess-state.vala"
			if (type) {
#line 817 "../lib/chess-state.vala"
				*type = _vala_type;
#line 3940 "chess-state.c"
			}
#line 817 "../lib/chess-state.vala"
			return result;
#line 3944 "chess-state.c"
		}
	}
}

static gboolean
chess_state_decode_move (ChessState* self,
                         ChessPlayer* player,
                         const gchar* move,
                         gint* r0,
                         gint* f0,
                         gint* r1,
                         gint* f1,
                         PieceType* promotion_type)
{
	gint _vala_r0 = 0;
	gint _vala_f0 = 0;
	gint _vala_r1 = 0;
	gint _vala_f1 = 0;
	PieceType _vala_promotion_type = 0;
	gint i = 0;
	gboolean result;
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 823 "../lib/chess-state.vala"
	i = 0;
#line 825 "../lib/chess-state.vala"
	_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 826 "../lib/chess-state.vala"
	if (g_str_has_prefix (move, "O-O-O")) {
#line 3978 "chess-state.c"
		gint _tmp0_;
		gint _tmp1_;
#line 828 "../lib/chess-state.vala"
		if (player->color == COLOR_WHITE) {
#line 829 "../lib/chess-state.vala"
			_vala_r1 = 0;
#line 829 "../lib/chess-state.vala"
			_vala_r0 = _vala_r1;
#line 3987 "chess-state.c"
		} else {
#line 831 "../lib/chess-state.vala"
			_vala_r1 = 7;
#line 831 "../lib/chess-state.vala"
			_vala_r0 = _vala_r1;
#line 3993 "chess-state.c"
		}
#line 832 "../lib/chess-state.vala"
		_vala_f0 = 4;
#line 833 "../lib/chess-state.vala"
		_vala_f1 = 2;
#line 834 "../lib/chess-state.vala"
		_tmp0_ = strlen ("O-O-O");
#line 834 "../lib/chess-state.vala"
		_tmp1_ = _tmp0_;
#line 834 "../lib/chess-state.vala"
		i += (gint) _tmp1_;
#line 4005 "chess-state.c"
	} else {
#line 836 "../lib/chess-state.vala"
		if (g_str_has_prefix (move, "O-O")) {
#line 4009 "chess-state.c"
			gint _tmp2_;
			gint _tmp3_;
#line 838 "../lib/chess-state.vala"
			if (player->color == COLOR_WHITE) {
#line 839 "../lib/chess-state.vala"
				_vala_r1 = 0;
#line 839 "../lib/chess-state.vala"
				_vala_r0 = _vala_r1;
#line 4018 "chess-state.c"
			} else {
#line 841 "../lib/chess-state.vala"
				_vala_r1 = 7;
#line 841 "../lib/chess-state.vala"
				_vala_r0 = _vala_r1;
#line 4024 "chess-state.c"
			}
#line 842 "../lib/chess-state.vala"
			_vala_f0 = 4;
#line 843 "../lib/chess-state.vala"
			_vala_f1 = 6;
#line 844 "../lib/chess-state.vala"
			_tmp2_ = strlen ("O-O");
#line 844 "../lib/chess-state.vala"
			_tmp3_ = _tmp2_;
#line 844 "../lib/chess-state.vala"
			i += (gint) _tmp3_;
#line 4036 "chess-state.c"
		} else {
			PieceType type = 0;
			PieceType _tmp4_ = 0;
			gboolean _tmp5_;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp25_ = FALSE;
			gboolean _tmp26_ = FALSE;
#line 848 "../lib/chess-state.vala"
			type = PIECE_TYPE_PAWN;
#line 849 "../lib/chess-state.vala"
			_tmp5_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) i), &_tmp4_);
#line 849 "../lib/chess-state.vala"
			type = _tmp4_;
#line 849 "../lib/chess-state.vala"
			if (_tmp5_) {
#line 4056 "chess-state.c"
				gint _tmp6_;
#line 850 "../lib/chess-state.vala"
				_tmp6_ = i;
#line 850 "../lib/chess-state.vala"
				i = _tmp6_ + 1;
#line 4062 "chess-state.c"
			}
#line 852 "../lib/chess-state.vala"
			_vala_f1 = -1;
#line 852 "../lib/chess-state.vala"
			_vala_r1 = _vala_f1;
#line 852 "../lib/chess-state.vala"
			_vala_f0 = _vala_r1;
#line 852 "../lib/chess-state.vala"
			_vala_r0 = _vala_f0;
#line 853 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= 'a') {
#line 853 "../lib/chess-state.vala"
				_tmp7_ = string_get (move, (glong) i) <= 'h';
#line 4076 "chess-state.c"
			} else {
#line 853 "../lib/chess-state.vala"
				_tmp7_ = FALSE;
#line 4080 "chess-state.c"
			}
#line 853 "../lib/chess-state.vala"
			if (_tmp7_) {
#line 4084 "chess-state.c"
				gint _tmp8_;
#line 855 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) i) - 'a');
#line 856 "../lib/chess-state.vala"
				_tmp8_ = i;
#line 856 "../lib/chess-state.vala"
				i = _tmp8_ + 1;
#line 4092 "chess-state.c"
			}
#line 858 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= '1') {
#line 858 "../lib/chess-state.vala"
				_tmp9_ = string_get (move, (glong) i) <= '8';
#line 4098 "chess-state.c"
			} else {
#line 858 "../lib/chess-state.vala"
				_tmp9_ = FALSE;
#line 4102 "chess-state.c"
			}
#line 858 "../lib/chess-state.vala"
			if (_tmp9_) {
#line 4106 "chess-state.c"
				gint _tmp10_;
#line 860 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) i) - '1');
#line 861 "../lib/chess-state.vala"
				_tmp10_ = i;
#line 861 "../lib/chess-state.vala"
				i = _tmp10_ + 1;
#line 4114 "chess-state.c"
			}
#line 863 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) == 'x') {
#line 863 "../lib/chess-state.vala"
				_tmp11_ = TRUE;
#line 4120 "chess-state.c"
			} else {
#line 863 "../lib/chess-state.vala"
				_tmp11_ = string_get (move, (glong) i) == '-';
#line 4124 "chess-state.c"
			}
#line 863 "../lib/chess-state.vala"
			if (_tmp11_) {
#line 4128 "chess-state.c"
				gint _tmp12_;
#line 864 "../lib/chess-state.vala"
				_tmp12_ = i;
#line 864 "../lib/chess-state.vala"
				i = _tmp12_ + 1;
#line 4134 "chess-state.c"
			}
#line 865 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= 'a') {
#line 865 "../lib/chess-state.vala"
				_tmp13_ = string_get (move, (glong) i) <= 'h';
#line 4140 "chess-state.c"
			} else {
#line 865 "../lib/chess-state.vala"
				_tmp13_ = FALSE;
#line 4144 "chess-state.c"
			}
#line 865 "../lib/chess-state.vala"
			if (_tmp13_) {
#line 4148 "chess-state.c"
				gint _tmp14_;
#line 867 "../lib/chess-state.vala"
				_vala_f0 = _vala_f1;
#line 868 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) i) - 'a');
#line 869 "../lib/chess-state.vala"
				_tmp14_ = i;
#line 869 "../lib/chess-state.vala"
				i = _tmp14_ + 1;
#line 4158 "chess-state.c"
			}
#line 871 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) >= '1') {
#line 871 "../lib/chess-state.vala"
				_tmp15_ = string_get (move, (glong) i) <= '8';
#line 4164 "chess-state.c"
			} else {
#line 871 "../lib/chess-state.vala"
				_tmp15_ = FALSE;
#line 4168 "chess-state.c"
			}
#line 871 "../lib/chess-state.vala"
			if (_tmp15_) {
#line 4172 "chess-state.c"
				gint _tmp16_;
#line 873 "../lib/chess-state.vala"
				_vala_r0 = _vala_r1;
#line 874 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) i) - '1');
#line 875 "../lib/chess-state.vala"
				_tmp16_ = i;
#line 875 "../lib/chess-state.vala"
				i = _tmp16_ + 1;
#line 4182 "chess-state.c"
			}
#line 877 "../lib/chess-state.vala"
			if (string_get (move, (glong) i) == '=') {
#line 4186 "chess-state.c"
				gint _tmp17_;
				PieceType _tmp18_ = 0;
				gboolean _tmp19_;
#line 879 "../lib/chess-state.vala"
				_tmp17_ = i;
#line 879 "../lib/chess-state.vala"
				i = _tmp17_ + 1;
#line 880 "../lib/chess-state.vala"
				_tmp19_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) i), &_tmp18_);
#line 880 "../lib/chess-state.vala"
				_vala_promotion_type = _tmp18_;
#line 880 "../lib/chess-state.vala"
				if (_tmp19_) {
#line 4200 "chess-state.c"
					gint _tmp20_;
#line 881 "../lib/chess-state.vala"
					_tmp20_ = i;
#line 881 "../lib/chess-state.vala"
					i = _tmp20_ + 1;
#line 4206 "chess-state.c"
				}
			} else {
#line 883 "../lib/chess-state.vala"
				if (string_get (move, (glong) i) != '\0') {
#line 885 "../lib/chess-state.vala"
					switch (string_get (move, (glong) i)) {
#line 885 "../lib/chess-state.vala"
						case 'q':
#line 885 "../lib/chess-state.vala"
						case 'Q':
#line 4217 "chess-state.c"
						{
							gint _tmp21_;
#line 889 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 890 "../lib/chess-state.vala"
							_tmp21_ = i;
#line 890 "../lib/chess-state.vala"
							i = _tmp21_ + 1;
#line 891 "../lib/chess-state.vala"
							break;
#line 4228 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'n':
#line 885 "../lib/chess-state.vala"
						case 'N':
#line 4234 "chess-state.c"
						{
							gint _tmp22_;
#line 894 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_KNIGHT;
#line 895 "../lib/chess-state.vala"
							_tmp22_ = i;
#line 895 "../lib/chess-state.vala"
							i = _tmp22_ + 1;
#line 896 "../lib/chess-state.vala"
							break;
#line 4245 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'r':
#line 885 "../lib/chess-state.vala"
						case 'R':
#line 4251 "chess-state.c"
						{
							gint _tmp23_;
#line 899 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_ROOK;
#line 900 "../lib/chess-state.vala"
							_tmp23_ = i;
#line 900 "../lib/chess-state.vala"
							i = _tmp23_ + 1;
#line 901 "../lib/chess-state.vala"
							break;
#line 4262 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'b':
#line 885 "../lib/chess-state.vala"
						case 'B':
#line 4268 "chess-state.c"
						{
							gint _tmp24_;
#line 904 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_BISHOP;
#line 905 "../lib/chess-state.vala"
							_tmp24_ = i;
#line 905 "../lib/chess-state.vala"
							i = _tmp24_ + 1;
#line 906 "../lib/chess-state.vala"
							break;
#line 4279 "chess-state.c"
						}
						default:
#line 885 "../lib/chess-state.vala"
						break;
#line 4284 "chess-state.c"
					}
				}
			}
#line 911 "../lib/chess-state.vala"
			if (_vala_r1 < 0) {
#line 911 "../lib/chess-state.vala"
				_tmp25_ = TRUE;
#line 4292 "chess-state.c"
			} else {
#line 911 "../lib/chess-state.vala"
				_tmp25_ = _vala_f1 < 0;
#line 4296 "chess-state.c"
			}
#line 911 "../lib/chess-state.vala"
			if (_tmp25_) {
#line 913 "../lib/chess-state.vala"
				g_debug ("chess-state.vala:913: Move %s missing destination", move);
#line 914 "../lib/chess-state.vala"
				result = FALSE;
#line 914 "../lib/chess-state.vala"
				if (r0) {
#line 914 "../lib/chess-state.vala"
					*r0 = _vala_r0;
#line 4308 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (f0) {
#line 914 "../lib/chess-state.vala"
					*f0 = _vala_f0;
#line 4314 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (r1) {
#line 914 "../lib/chess-state.vala"
					*r1 = _vala_r1;
#line 4320 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (f1) {
#line 914 "../lib/chess-state.vala"
					*f1 = _vala_f1;
#line 4326 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (promotion_type) {
#line 914 "../lib/chess-state.vala"
					*promotion_type = _vala_promotion_type;
#line 4332 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				return result;
#line 4336 "chess-state.c"
			}
#line 918 "../lib/chess-state.vala"
			if (_vala_r0 < 0) {
#line 918 "../lib/chess-state.vala"
				_tmp26_ = TRUE;
#line 4342 "chess-state.c"
			} else {
#line 918 "../lib/chess-state.vala"
				_tmp26_ = _vala_f0 < 0;
#line 4346 "chess-state.c"
			}
#line 918 "../lib/chess-state.vala"
			if (_tmp26_) {
#line 4350 "chess-state.c"
				gint match_rank = 0;
				gint match_file = 0;
#line 920 "../lib/chess-state.vala"
				match_rank = -1;
#line 920 "../lib/chess-state.vala"
				match_file = -1;
#line 4357 "chess-state.c"
				{
					gint file = 0;
#line 922 "../lib/chess-state.vala"
					file = 0;
#line 4362 "chess-state.c"
					{
						gboolean _tmp27_ = FALSE;
#line 922 "../lib/chess-state.vala"
						_tmp27_ = TRUE;
#line 922 "../lib/chess-state.vala"
						while (TRUE) {
#line 4369 "chess-state.c"
							gboolean _tmp29_ = FALSE;
#line 922 "../lib/chess-state.vala"
							if (!_tmp27_) {
#line 4373 "chess-state.c"
								gint _tmp28_;
#line 922 "../lib/chess-state.vala"
								_tmp28_ = file;
#line 922 "../lib/chess-state.vala"
								file = _tmp28_ + 1;
#line 4379 "chess-state.c"
							}
#line 922 "../lib/chess-state.vala"
							_tmp27_ = FALSE;
#line 922 "../lib/chess-state.vala"
							if (!(file < 8)) {
#line 922 "../lib/chess-state.vala"
								break;
#line 4387 "chess-state.c"
							}
#line 924 "../lib/chess-state.vala"
							if (_vala_f0 >= 0) {
#line 924 "../lib/chess-state.vala"
								_tmp29_ = file != _vala_f0;
#line 4393 "chess-state.c"
							} else {
#line 924 "../lib/chess-state.vala"
								_tmp29_ = FALSE;
#line 4397 "chess-state.c"
							}
#line 924 "../lib/chess-state.vala"
							if (_tmp29_) {
#line 925 "../lib/chess-state.vala"
								continue;
#line 4403 "chess-state.c"
							}
							{
								gint rank = 0;
#line 927 "../lib/chess-state.vala"
								rank = 0;
#line 4409 "chess-state.c"
								{
									gboolean _tmp30_ = FALSE;
#line 927 "../lib/chess-state.vala"
									_tmp30_ = TRUE;
#line 927 "../lib/chess-state.vala"
									while (TRUE) {
#line 4416 "chess-state.c"
										gboolean _tmp32_ = FALSE;
										ChessPiece* piece = NULL;
										ChessPiece* _tmp33_;
										ChessPiece* _tmp34_;
										gboolean _tmp35_ = FALSE;
										gboolean _tmp36_ = FALSE;
										ChessPiece* _tmp37_;
#line 927 "../lib/chess-state.vala"
										if (!_tmp30_) {
#line 4426 "chess-state.c"
											gint _tmp31_;
#line 927 "../lib/chess-state.vala"
											_tmp31_ = rank;
#line 927 "../lib/chess-state.vala"
											rank = _tmp31_ + 1;
#line 4432 "chess-state.c"
										}
#line 927 "../lib/chess-state.vala"
										_tmp30_ = FALSE;
#line 927 "../lib/chess-state.vala"
										if (!(rank < 8)) {
#line 927 "../lib/chess-state.vala"
											break;
#line 4440 "chess-state.c"
										}
#line 929 "../lib/chess-state.vala"
										if (_vala_r0 >= 0) {
#line 929 "../lib/chess-state.vala"
											_tmp32_ = rank != _vala_r0;
#line 4446 "chess-state.c"
										} else {
#line 929 "../lib/chess-state.vala"
											_tmp32_ = FALSE;
#line 4450 "chess-state.c"
										}
#line 929 "../lib/chess-state.vala"
										if (_tmp32_) {
#line 930 "../lib/chess-state.vala"
											continue;
#line 4456 "chess-state.c"
										}
#line 933 "../lib/chess-state.vala"
										_tmp33_ = self->board[chess_state_get_index (self, rank, file)];
#line 933 "../lib/chess-state.vala"
										_tmp34_ = _g_object_ref0 (_tmp33_);
#line 933 "../lib/chess-state.vala"
										piece = _tmp34_;
#line 934 "../lib/chess-state.vala"
										_tmp37_ = piece;
#line 934 "../lib/chess-state.vala"
										if (_tmp37_ == NULL) {
#line 934 "../lib/chess-state.vala"
											_tmp36_ = TRUE;
#line 4470 "chess-state.c"
										} else {
											ChessPiece* _tmp38_;
#line 934 "../lib/chess-state.vala"
											_tmp38_ = piece;
#line 934 "../lib/chess-state.vala"
											_tmp36_ = _tmp38_->type != type;
#line 4477 "chess-state.c"
										}
#line 934 "../lib/chess-state.vala"
										if (_tmp36_) {
#line 934 "../lib/chess-state.vala"
											_tmp35_ = TRUE;
#line 4483 "chess-state.c"
										} else {
											ChessPiece* _tmp39_;
											ChessPlayer* _tmp40_;
#line 934 "../lib/chess-state.vala"
											_tmp39_ = piece;
#line 934 "../lib/chess-state.vala"
											_tmp40_ = _tmp39_->player;
#line 934 "../lib/chess-state.vala"
											_tmp35_ = _tmp40_ != player;
#line 4493 "chess-state.c"
										}
#line 934 "../lib/chess-state.vala"
										if (_tmp35_) {
#line 935 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 935 "../lib/chess-state.vala"
											continue;
#line 4501 "chess-state.c"
										}
#line 938 "../lib/chess-state.vala"
										if (!chess_state_move_with_coords (self, player, rank, file, _vala_r1, _vala_f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 939 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 939 "../lib/chess-state.vala"
											continue;
#line 4509 "chess-state.c"
										}
#line 942 "../lib/chess-state.vala"
										if (match_rank >= 0) {
#line 944 "../lib/chess-state.vala"
											g_debug ("chess-state.vala:944: Move %s is ambiguous", move);
#line 945 "../lib/chess-state.vala"
											result = FALSE;
#line 945 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 945 "../lib/chess-state.vala"
											if (r0) {
#line 945 "../lib/chess-state.vala"
												*r0 = _vala_r0;
#line 4523 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (f0) {
#line 945 "../lib/chess-state.vala"
												*f0 = _vala_f0;
#line 4529 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (r1) {
#line 945 "../lib/chess-state.vala"
												*r1 = _vala_r1;
#line 4535 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (f1) {
#line 945 "../lib/chess-state.vala"
												*f1 = _vala_f1;
#line 4541 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (promotion_type) {
#line 945 "../lib/chess-state.vala"
												*promotion_type = _vala_promotion_type;
#line 4547 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											return result;
#line 4551 "chess-state.c"
										}
#line 948 "../lib/chess-state.vala"
										match_rank = rank;
#line 949 "../lib/chess-state.vala"
										match_file = file;
#line 927 "../lib/chess-state.vala"
										_g_object_unref0 (piece);
#line 4559 "chess-state.c"
									}
								}
							}
						}
					}
				}
#line 953 "../lib/chess-state.vala"
				if (match_rank < 0) {
#line 955 "../lib/chess-state.vala"
					g_debug ("chess-state.vala:955: Move %s has no matches", move);
#line 956 "../lib/chess-state.vala"
					result = FALSE;
#line 956 "../lib/chess-state.vala"
					if (r0) {
#line 956 "../lib/chess-state.vala"
						*r0 = _vala_r0;
#line 4576 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (f0) {
#line 956 "../lib/chess-state.vala"
						*f0 = _vala_f0;
#line 4582 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (r1) {
#line 956 "../lib/chess-state.vala"
						*r1 = _vala_r1;
#line 4588 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (f1) {
#line 956 "../lib/chess-state.vala"
						*f1 = _vala_f1;
#line 4594 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (promotion_type) {
#line 956 "../lib/chess-state.vala"
						*promotion_type = _vala_promotion_type;
#line 4600 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					return result;
#line 4604 "chess-state.c"
				}
#line 959 "../lib/chess-state.vala"
				_vala_r0 = match_rank;
#line 960 "../lib/chess-state.vala"
				_vala_f0 = match_file;
#line 4610 "chess-state.c"
			}
		}
	}
#line 964 "../lib/chess-state.vala"
	if (string_get (move, (glong) i) == '+') {
#line 4616 "chess-state.c"
		gint _tmp41_;
#line 965 "../lib/chess-state.vala"
		_tmp41_ = i;
#line 965 "../lib/chess-state.vala"
		i = _tmp41_ + 1;
#line 4622 "chess-state.c"
	} else {
#line 966 "../lib/chess-state.vala"
		if (string_get (move, (glong) i) == '#') {
#line 4626 "chess-state.c"
			gint _tmp42_;
#line 967 "../lib/chess-state.vala"
			_tmp42_ = i;
#line 967 "../lib/chess-state.vala"
			i = _tmp42_ + 1;
#line 4632 "chess-state.c"
		}
	}
#line 969 "../lib/chess-state.vala"
	if (string_get (move, (glong) i) != '\0') {
#line 971 "../lib/chess-state.vala"
		g_debug ("chess-state.vala:971: Move %s has unexpected characters", move);
#line 972 "../lib/chess-state.vala"
		result = FALSE;
#line 972 "../lib/chess-state.vala"
		if (r0) {
#line 972 "../lib/chess-state.vala"
			*r0 = _vala_r0;
#line 4645 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (f0) {
#line 972 "../lib/chess-state.vala"
			*f0 = _vala_f0;
#line 4651 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (r1) {
#line 972 "../lib/chess-state.vala"
			*r1 = _vala_r1;
#line 4657 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (f1) {
#line 972 "../lib/chess-state.vala"
			*f1 = _vala_f1;
#line 4663 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (promotion_type) {
#line 972 "../lib/chess-state.vala"
			*promotion_type = _vala_promotion_type;
#line 4669 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		return result;
#line 4673 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	result = TRUE;
#line 975 "../lib/chess-state.vala"
	if (r0) {
#line 975 "../lib/chess-state.vala"
		*r0 = _vala_r0;
#line 4681 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (f0) {
#line 975 "../lib/chess-state.vala"
		*f0 = _vala_f0;
#line 4687 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (r1) {
#line 975 "../lib/chess-state.vala"
		*r1 = _vala_r1;
#line 4693 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (f1) {
#line 975 "../lib/chess-state.vala"
		*f1 = _vala_f1;
#line 4699 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (promotion_type) {
#line 975 "../lib/chess-state.vala"
		*promotion_type = _vala_promotion_type;
#line 4705 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	return result;
#line 4709 "chess-state.c"
}

ChessPlayer*
chess_state_get_opponent (ChessState* self)
{
	ChessPlayer* result;
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* _tmp1_;
#line 27 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/chess-state.vala"
	_tmp1_ = self->current_player;
#line 27 "../lib/chess-state.vala"
	if (_tmp1_->color == COLOR_WHITE) {
#line 4724 "chess-state.c"
		ChessPlayer* _tmp2_;
#line 27 "../lib/chess-state.vala"
		_tmp2_ = self->players[COLOR_BLACK];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp2_;
#line 4730 "chess-state.c"
	} else {
		ChessPlayer* _tmp3_;
#line 27 "../lib/chess-state.vala"
		_tmp3_ = self->players[COLOR_WHITE];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp3_;
#line 4737 "chess-state.c"
	}
#line 27 "../lib/chess-state.vala"
	result = _tmp0_;
#line 27 "../lib/chess-state.vala"
	return result;
#line 4743 "chess-state.c"
}

static void
chess_state_class_init (ChessStateClass * klass,
                        gpointer klass_data)
{
#line 20 "../lib/chess-state.vala"
	chess_state_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/chess-state.vala"
	g_type_class_adjust_private_offset (klass, &ChessState_private_offset);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_state_get_property;
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_state_finalize;
#line 20 "../lib/chess-state.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_STATE_OPPONENT_PROPERTY, chess_state_properties[CHESS_STATE_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4760 "chess-state.c"
}

static void
chess_state_instance_init (ChessState * self,
                           gpointer klass)
{
#line 20 "../lib/chess-state.vala"
	self->priv = chess_state_get_instance_private (self);
#line 22 "../lib/chess-state.vala"
	self->number = 0;
#line 31 "../lib/chess-state.vala"
	self->en_passant_index = -1;
#line 36 "../lib/chess-state.vala"
	self->last_move = NULL;
#line 4775 "chess-state.c"
}

static void
chess_state_finalize (GObject * obj)
{
	ChessState * self;
#line 20 "../lib/chess-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_STATE, ChessState);
#line 23 "../lib/chess-state.vala"
	_vala_array_destroy (self->players, 2, (GDestroyNotify) g_object_unref);
#line 24 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 35 "../lib/chess-state.vala"
	_vala_array_destroy (self->board, 64, (GDestroyNotify) g_object_unref);
#line 36 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (chess_state_parent_class)->finalize (obj);
#line 4794 "chess-state.c"
}

static GType
chess_state_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessState), 0, (GInstanceInitFunc) chess_state_instance_init, NULL };
	GType chess_state_type_id;
	chess_state_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessState", &g_define_type_info, 0);
	ChessState_private_offset = g_type_add_instance_private (chess_state_type_id, sizeof (ChessStatePrivate));
	return chess_state_type_id;
}

GType
chess_state_get_type (void)
{
	static volatile gsize chess_state_type_id__once = 0;
	if (g_once_init_enter (&chess_state_type_id__once)) {
		GType chess_state_type_id;
		chess_state_type_id = chess_state_get_type_once ();
		g_once_init_leave (&chess_state_type_id__once, chess_state_type_id);
	}
	return chess_state_type_id__once;
}

static void
_vala_chess_state_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_STATE, ChessState);
#line 20 "../lib/chess-state.vala"
	switch (property_id) {
#line 20 "../lib/chess-state.vala"
		case CHESS_STATE_OPPONENT_PROPERTY:
#line 20 "../lib/chess-state.vala"
		g_value_set_object (value, chess_state_get_opponent (self));
#line 20 "../lib/chess-state.vala"
		break;
#line 4835 "chess-state.c"
		default:
#line 20 "../lib/chess-state.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/chess-state.vala"
		break;
#line 4841 "chess-state.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

